/**
 * This is the JavaScript portion of the Magic Browser Client.
 * Copyright 2000 Magic Software Enterprises Ltd. All rights reserved (c).
 * MGBrowserClient.js version 9.4
 */

/************************************************************************/
/* Global Variables                                                     */
/************************************************************************/
// global define for strings
var WND_FEATURES                 = "toolbar=0, directories=0, menubar=0, status=1, resizable=yes, location=0, scrollbars=yes";
var WND_FEATURES_FULL            = "toolbar=1, directories=1, menubar=1, status=1, resizable=yes, location=0, scrollbars=yes";

var MG_WINDOW_TASK      = 0;

var IsMS_JVM            = false;

// Magics control types
var CTRL_TYPE_BUTTON    = 'B';
var CTRL_TYPE_CHECKBOX  = 'C';
var CTRL_TYPE_RADIO     = 'R';
var CTRL_TYPE_SELECT    = 'S';
var CTRL_TYPE_TEXT      = 'T';
var CTRL_TYPE_STATIC    = 'L';
var CTRL_TYPE_TABLE     = 'A';
var CTRL_TYPE_IMAGE     = 'I';
var CTRL_TYPE_HYPERTEXT = 'H';
var CTRL_TYPE_IFRAME    = 'M';

// define HTML types
var CTRL_HTMLTYPE_INPUT       = "INPUT";
var CTRL_HTMLTYPE_CHECKBOX    = "CHECKBOX";
var CTRL_HTMLTYPE_SELECT      = "SELECT";
var CTRL_HTMLTYPE_BUTTON      = "BUTTON";
var CTRL_HTMLTYPE_PASSWORD    = "PASSWORD";
var CTRL_HTMLTYPE_TEXTAREA    = "TEXTAREA";
var CTRL_HTMLTYPE_RADIO       = "RADIO";
var CTRL_HTMLTYPE_TEXT        = "TEXT";
var CTRL_HTMLTYPE_SELECT_MULT = "select-multiple";
var CTRL_HTMLTYPE_SELECT_ONE  = "select-one";
var CTRL_HTMLTYPE_OPTION      = "OPTION";
var CTRL_HTMLTYPE_IMG         = "IMG";
var CTRL_HTMLTYPE_IMAGE       = "IMAGE";
var CTRL_HTMLTYPE_TABLE       = "TABLE";
var CTRL_HTMLTYPE_HTML        = "HTML";
var CTRL_HTMLTYPE_BODY        = "BODY";
var CTRL_HTMLTYPE_TR          = "TR";
var CTRL_HTMLTYPE_IFRAME     = "IFRAME";
// types of Magics hypertext "H":
var CTRL_HTMLTYPE_ANCHOR      = "A";      // tagName
var CTRL_HTMLTYPE_DIV         = "DIV";    // tagName

// java script types
var JS_TYPE_NUMBER      = "number"; ;
var JS_TYPE_BOOLEAN     = "boolean";
var JS_TYPE_STRING      = "string";
var JS_TYPE_OBJ         = "object";
var JS_TYPE_UNDEF       = "undefined";
var JS_TYPE_UNKNOWN     = "unknown";

var JS_TRANSPARENT      = "transparent";  // for using of transparent class properties of object

var EMPTY_STR           = "";
var SPACE_STR           = " ";
var ZERO_STR            = "0";
var ONE_STR             = "1";
var HTML_COMMA          = "&#044;"           // has to be the same as ConstInterface.HTML_COMMA
var COMMA_STR           = ",";
var RTL_STR             = "rtl";
var LTR_STR             = "ltr";
var RIGHT_BUTTON_PRESSED = "2";

var HIDDEN_CSS          = "hidden";
var VISIBLE_CSS         = "visible";
var DISPLAYNON_CSS      = "none"

// event constants
var MOUSEDOWN           = "mousedown";
var MOUSEMOVE           = "mousemove";
var MOUSEOVER           = "mouseover";
var MOUSEOUT            = "mouseout";
var MOUSEUP             = "mouseup";
var BLUR                = "blur";
var KEYDOWN             = "keydown";
var FOCUS               = "focus";
var LOAD                = "load";
var UNLOAD              = "unload";
var CLICK               = "click";
var SELECTSTART         = "selectstart";
var SELECT              = "select";
var HELP                = "help";
var MOUSEWHEEL          = "mousewheel";
var TIMER               = "timer";
var EXTERNAL            = "external";
var RESIZE              = "resize";
var MOVE                = "move";

// Magic navigation controls names
var MG_VCR             = "MG_VCR";
var MG_EDIT            = "MG_EDIT";
var MG_CANCEL          = "MG_CANCEL";
var MG_EXIT            = "MG_EXIT";
var MG_QUIT            = "MG_QUIT";

// Key definition
var KEY_ESC            = 27;
var KEY_END            = 35;
var KEY_CTRL           = 16;
var KEY_SHIFT          = 18;

var OPENWIN_TIMER      = 9876;

// Process Event return code
var PROCESS_EVENT_OK         = "K";
var PROCESS_EVENT_EXIT       = "E";
var PROCESS_EVENT_RETRY      = "R";
var PROCESS_EVENT_BUSY_RETRY = "B";

var EXPLORER_HELP      = "EXPLORER_HELP";
var MAGIC_HELP         = "MAGIC_HELP";

// global variables for every HTML page. inside 'window' DOM object
var isMagicEvent        = false;             // the event handled by Magic, need not handle it by browser
var isNumberingDone     = false;             // is all objects in the page initialized
var isFrameSet          = false;             // is the window opened in Frame
var overlayingFrame     = false;             // True when we overlay one of our own framesets by another

var appletRef           = null;              // reference to magic applet in every magic window
var mainWnd             = null;              // reference to main window in every magic window
var logicalOpener       = null;              // most time equals to window.opener
var isAborting          = false;             // the flag for closing window; window, which going to be closed set the flag to true
var debugMode           = 0;                 // Are we running in debug mode? (0 = no debug, 1 = client level)
var errorsWnd           = null;              // Window used to display error messages
var errorsList          = EMPTY_STR;         // All error messages acummulated so far
var helpServed          = false;             // True if the help event was served by Magic
var lastMouseOverName   = EMPTY_STR;         // Name of last control, has fired mouseover event.
var NAMES_SEPARATOR     = "#+%";             // used to separate control names in a string
var displayMagicHelp    = "";                // used when help event must be redone,
                                             // may have EXPLORER_HELP or MAGIC_HELP values;
var controlToClick      = new Array();       // control used in "propogate click event" mechanizm
var cntrlToClckArrlength = 0                 // length of controlToClickName array
var maxNumofstoredClicks = 10                // Maximum number of stored click events (for Astra enviroment only)
var controlToClickBegin = false;             // flag indicates "propogate click event" action
var inOpenWin           = false;             // True if we are in the middle of openning a window
var newWinInterval      = null;
var doNullify           = true;
var preventFocusExec    = false;             // prevents execution of focus, when obtain focus is used
                                             // only to set correct current window
var abortFlag           = false;             // prevents endless loop in callProcessEvent for unload event
                                             // with no parkable controls
var winAsFrame          = false;             // Windows opened via a call operation with destination frame has frame characateristics     
var appletDestroyed     = false;             // becomes TRUE when we are writing over the HTML in error conditions.
var afterCloseWin       = 0;                 // If non-zero, holds the time a window was last close
var inOpenWinTimer      = false;             // TRUE when openwin timer is running
var standAloneWin       = null;
var standAloneUrl       = null;

/************************************************************************/
/*EVENT PROCESSING                                                      */
/************************************************************************/

/**
 * process the browser event
 * @param event which got onblur event
 * for future use in NN (in IE it's possible to get window.event in the function)
 * to get reference to the element object that fired the current event
 * (IE): window.event.srcElement  (NN): e.target
 */
function MGEventProcessing(evt)
{
   var oldWinNum = -1;

   if (evt == null)
   {
      evt = event;
      if (evt == null)
         return;
   }

   var type    = evt.type;
   var source  = evt.srcElement;

   if (type == KEYDOWN)
      setMagicEventCurrWnd(false);

   if (type == LOAD && isImg(source))   // loading Image
   {
      if (objExists(appletRef) && !isUnKnown(numberWnd))  // the loading of the image has came before load of the window itself
         callProcessEvent(appletRef, type, source.name, source.value, source.number, source.tsk, numberWnd, null, null);
      return true;
   }
   else if (type == LOAD)               // loading the page
   {
      // setup the document event handlers
      document.onclick        = MGEventProcessing;
      document.ondblclick     = MGEventProcessing;
      document.onmouseover    = MGEventProcessing;
      document.onmouseout     = MGEventProcessing;
      document.onmousedown    = MGEventProcessing;
      document.onmouseup      = MGEventProcessing;
      document.onmousemove    = MGEventProcessing;
      document.onhelp         = MGEventProcessing;
      document.onmousewheel   = MGEventProcessing;

      // prevent submiting
      if (objExists(document.forms[0]))
         document.forms[0].onsubmit = new Function("return false; ");

      if (typeof document.ClientManager == JS_TYPE_OBJ) // this is first - main window
      {
         status = SPACE_STR;
         initNumbering(true, false, null, 0);
         callProcessEvent(appletRef, type, null, EMPTY_STR, null, null, number, null, null);
      }
      return;
   }
   else if (type == UNLOAD)
   {
      checkUnLoad();
      return true;
   }

   if (isAborting)
      return false;

   // don't open next (child) window, while parsing/loading father window
   if (!self.isLoaded || isWndClosed(self.numberWnd))
      return;

   // not found main window with applet or it's not 'magic' program window
   if (isUnKnown(typeof numberWnd) || getMainWnd()==null)
      return;

   // return the focus to the current window or check the valid current window
   if (numberWnd != getCurrWnd())
   {
      //QCR 989282 - MOVE events should not change the current window
      if (type == MOUSEOVER || type == MOUSEOUT || type == SELECTSTART || type == SELECT || type == MOUSEMOVE || type == MOVE)
      {
         var currWndRef = getWin(getCurrWnd());

         // TODO: remove the "try ... catch" when the UNLOAD handler resets the current window correctly
         try
         {
            if (objExists(currWndRef) && getWin(numberWnd).top == getWin(getCurrWnd()).top)
               oldWinNum = getCurrWnd();
            else
            {
               evt.cancelBubble = true;
               return true;
            }
         }
         catch (e)
         {
            evt.cancelBubble = true;
            return true;
         }
      }
      else
      {
         obtainFocus(numberWnd, false);
         // After checking window still must process current event (don't lose it)
         // if the window was not changed and needs process the event
         if (numberWnd == getCurrWnd())
            return MGEventProcessing(evt);
         else
         {
            // delete consequences of click for select in non-modal windows
            if (type == CLICK && isSelectCtrl(source))
               source.value = source.oldValue;

            return false; // QCR #777627
         }
      }
   }

   // these events used for avoiding selecting in non current windows
   if (type == SELECTSTART || type == SELECT)
      return;

   var name;
   var value;
   var sourceType;
   var modifier   = null;
   var keyCode    = null;
   var appl       = getApplet();

   if (source == null)
   {
      obtainFocus(numberWnd, false);
      source      = window;
      name        = "MG_BROWSER_WINDOW";
      value       = EMPTY_STR;
      sourceType  = "window";
   }
   else
   {
      name       = source.name;
      value      = source.value;
      sourceType = source.type;
      if (sourceType != null)
         sourceType = sourceType.toUpperCase();
         
      //QCR 779341 - if there is no name try to take the id of the control
      //if there is no value property take the inner text
      if ( name == null || name == JS_TYPE_UNDEF)
         name = source.id;
         
      if ( value == null || value == JS_TYPE_UNDEF)
         value = source.innerText;
   }

   if (type != CLICK && type != MOUSEUP && isUnKnown(typeof source.number)|| (source.cancelProcessing && type == KEYDOWN)) // it's not Magic control
   {
      var src = getMagicParent(source);
      if (src == null)
         return;
      // a Magic parent control was found (DIV or A)
      source     = src;
      name       = source.name;
      value      = source.innerHTML;
      sourceType = source.type;
      if (sourceType != null)
         sourceType = sourceType.toUpperCase();
      
      //QCR 779341 - if there is no name try to take the id of the control
      //if there is no value property take the inner text
      if ( name == null || name == JS_TYPE_UNDEF)
         name = source.id;
         
      if ( value == null || value == JS_TYPE_UNDEF)
         value = source.innerText;

   }

   if (type == MOUSEOVER)
      lastMouseOverName = name;
   else if (type == MOUSEMOVE && (name == lastMouseOverName || !objExists(name)))
      return;

   if (name == MG_VCR || name == MG_EDIT || name == MG_CANCEL || name == MG_EXIT || name == MG_QUIT)
   {
      if (type == CLICK)
      {
         evt.cancelBubble = true;
         MGEventProcessingSpecial();
      }
      return;
   }

   if (sourceType == CTRL_HTMLTYPE_CHECKBOX)
   {
      if (source.checked)
         value = ONE_STR;
      else
         value = ZERO_STR;
   }

   if (type == KEYDOWN)
   {
      keyCode = evt.keyCode;

      // ignore CTRL, ALT or SHIFT if pressed alone
      if (keyCode >= KEY_CTRL && keyCode <= KEY_SHIFT)
         return;

      if (evt.altKey)
         modifier = "A";
      else if (evt.ctrlKey)
         modifier = "C";
      else if (evt.shiftKey)
         modifier = "S";
      else
         modifier = SPACE_STR;
   }

   if (type == MOUSEUP || type == MOUSEDOWN)
   {
      if (evt.button == RIGHT_BUTTON_PRESSED) //We ignore right button clicks.
          return;
   }
   
   // save last click coordinates for functions CLICK W/C X/Y - Magic functions
   if (type == MOUSEUP)
      appl.saveClickCoordinates(name, source.number, source.tsk, window.numberWnd,
                                 evt.clientX, evt.clientY, evt.offsetX, evt.offsetY);

   if (type == MOUSEWHEEL)
      keyCode = event.wheelDelta;
   callProcessEvent(appl, type, name, value, source.number, source.tsk, numberWnd, modifier, keyCode);

   if (type == KEYDOWN && displayMagicHelp != EMPTY_STR)
   {
      if (displayMagicHelp == MAGIC_HELP)
      // help was not executed proporly, execute again
         callProcessEvent(appl, HELP, name, value, source.number, source.tsk, numberWnd, modifier, keyCode);
      displayMagicHelp = EMPTY_STR;
   }

   if (controlToClickBegin)
     controlToClickBegin = false;
   else
   {
    var count;

    // Click event was find insdie  handler, now when handler execution
    // finished we propogaet click to right control
    for (count  = 0 ; count < cntrlToClckArrlength; count ++)
    {
       if (controlToClick[count] != null)
          callProcessEvent(appl, CLICK, controlToClick[count].name, value, controlToClick[count].num, controlToClick[count].tsk, numberWnd, modifier, keyCode);
       // Zeroing used values for garbage collector
       controlToClick[count] = null;
    }
    cntrlToClckArrlength = 0;
   }

   if (oldWinNum != -1)
      setCurrWnd(oldWinNum);

   check4Esc(evt);

   if (type == HELP && helpServed)
   {
      helpServed = false;
      return false;
   }

   // if the event was handled by Magic
   if (getMagicEvent() && type != RESIZE && type != MOVE && type != MOUSEOUT)
   {
      if (type == KEYDOWN)
      {
         // after verify handler insert to field last pressed letter
         // Ctrl+Q -> insert Q to the current field, need delete the letter
         evt.keyCode = null;
      }
      setMagicEventCurrWnd(false);
      return false;
   }
   if (source.readOnly && type == KEYDOWN)
		return false;

   // Ignore clicks on anchors. We open the URL during MOUSEUP.
   if (type == CLICK && typeof sourceType == JS_TYPE_STRING && typeof source.number != JS_TYPE_UNDEF)
   {
      if (sourceType == EMPTY_STR)
         sourceType = evt.srcElement.tagName;
         
      if (sourceType.toUpperCase() == CTRL_HTMLTYPE_ANCHOR)
         if (typeof evt.srcElement.href == JS_TYPE_STRING && evt.srcElement.href.length > 0)
            return false;
   }  
   
   return true;
}

function getCharset()
{
   if (typeof MG_LANG_VAR_ == JS_TYPE_STRING)
      return MG_LANG_VAR_;
   else
      return window.document.charset;
}

/**
 * a central method to call the process event in the applet
 */
function callProcessEvent(applet, type, name, value, srcNum, tsk, winNum, modifier, keyCode)
{
   /** 
    * This is used to synchronise the events in case of SUN JVM.
    * In MS JVM it is already synchronised.
    * This is a bug with SUN JVM (their bug reference 4838960)
    * Should be removed once this bug is fixed
    */
   if (!IsMS_JVM)
	   if (typeof document.all.MGcom == JS_TYPE_OBJ)
         document.all.MGcom.HookEvents(false);
   
   var eventCompleted = false;
   var result;
   var win = getWin(winNum);
   var activeCtrlName = null;
   var activeCtrlNumber = null;
   var activeCtrlTsk    = null;
   var activeParkable = false;
   var activeElement = null;
   // Ignore events if the whole applet is closing
    
   //compute parkability of active control, so we will not have to go back to JS later
   if (type == TIMER || type == MOUSEOVER || type == MOUSEDOWN || type == MOUSEUP || type == MOUSEOUT  || type == MOUSEMOVE)
   {
     //QCR 998438 the loacation of the try and catch should include all queries to activeElement
     try
     {
         if ( objExists(win) && objExists(win.document) &&  objExists(win.document.activeElement)) 
         {
               activeElement = win.document.activeElement;            
               if (objExists(activeElement) && typeof activeElement.name == JS_TYPE_STRING  
                 &&  typeof activeElement.number == JS_TYPE_STRING )
               {
                  activeCtrlName = activeElement.name;  
                  activeCtrlNumber =  activeElement.number;
                  activeCtrlTsk    = activeElement.tsk;
                  activeParkable =  isParkable(activeCtrlName, winNum);            
               }         
         }
     }
     catch (e)
     {
         activeCtrlName = null;
         activeCtrlNumber = null;
         activeCtrlTsk = null;
     }  

   }   
   
   if (win == null || applet == null || (IsMS_JVM && typeof applet.processEvent == JS_TYPE_UNDEF) || (!IsMS_JVM && applet.name != "ClientManager"))
   {
	   if (!IsMS_JVM)
		   if (typeof document.all.MGcom == JS_TYPE_OBJ)
	         document.all.MGcom.UnHookEvents(false);
      return;
   }

	try
	{
      do
      {
         result = applet.processEvent(type, name, value, srcNum, tsk, winNum, modifier, keyCode,
                   (name == null || name == "idle" ? false: isParkable(name, winNum)), activeCtrlName, activeCtrlNumber, activeCtrlTsk, activeParkable);
         if (result == PROCESS_EVENT_RETRY && typeof document.all.MGcom == JS_TYPE_OBJ)
            document.all.MGcom.ExecuteCmds("25;30;");
      } while (!abortFlag && result == PROCESS_EVENT_RETRY)
      
      while (!abortFlag && (result == PROCESS_EVENT_OK && !eventCompleted))
      {
         eventCompleted = applet.peekEndOfWork();
         applet.executeGuiCommands(winNum);
      }
      if (result == PROCESS_EVENT_OK && !appletDestroyed)
         applet.resetInJsLoop();
   }
   catch (e){result = PROCESS_EVENT_EXIT;}
   
	if (!IsMS_JVM)
	   if (typeof document.all.MGcom == JS_TYPE_OBJ)
	      document.all.MGcom.UnHookEvents(false);
	      
   return result;
}


/**
 * process the events of the VCR & EDIT toolbars
 */
function MGEventProcessingSpecial()
{
   var source  = event.srcElement;         // JSEvent name, Control name, Control value
   var type    = event.type;

   var numberOfButton = 1;
   if (source.name == MG_VCR)
      numberOfButton=6;
   else if (source.name == MG_EDIT)
      numberOfButton=3;
   // else if (source.name == MG_CANCEL || source.name == MG_EXIT)
   //   numberOfButton=1;

   numberOfButton = parseInt(event.offsetX / source.clientWidth * numberOfButton + 1);
   if (type == CLICK)
   {
      // send a number that represents the  button which was clicked
      callProcessEvent(getApplet(), type, source.name, numberOfButton, EMPTY_STR, source.tsk, window.numberWnd, null, null)
   }
   // change the tooltip of the EDIT
   else if (type == MOUSEOVER || type == MOUSEMOVE)
   {
      if (source.name == MG_VCR)
            setVCRTooltip(source, numberOfButton);
      else if (source.name == MG_EDIT)
            setEDITTooltip(source, numberOfButton);
      else if (source.name == MG_CANCEL)
            setCANCEL_EXITTooltip(source);
      else if (source.name == MG_EXIT)
            setCANCEL_EXITTooltip(source);
      else if (source.name == MG_QUIT)
            setCANCEL_EXITTooltip(source);
   }
}


/**
 * set the "isMagicEvent" flag value for the current window
 * @param isHandled current event
 */
function setMagicEventCurrWnd(isHandled)
{
   isMagicEvent = isHandled;
}

/**
 * set the "isMagicEvent" flag value
 * @param val the new value
 * @param winNum the window which owns the flag
 */
function setMagicEvent(val, winNum)
{
   val = var2bool(val);
   var win = getWin(winNum);

   if (win != null)
      win.isMagicEvent = val;
}

/**
 * stores the details for postphoned click event
 * @param name of control on which event will be implemented
 * @param number of control on which event will be implemented
 * @param task on which event will be implemented
 */
function controlDetails(name, number, task)
{
 this.name = name;
 this.num = number;
 this.tsk = task;
}


/**
 * set the "isMagicEvent" flag value
 * @param name of control to push into controlToClick array
 * @param number of control to push into controlToClic array
 * @param task to push into controlToClick array
 * @param winNum the window which owns the control
 */
function pushControlToClick(name, num, tsk, winNum)
{
   var win = getWin(winNum);
   var arrLength =  win.controlToClick.length;
   if (win != null)
   {
      // Prevent consequence clicks and handle clicks on non-focus window for Astra testing enviroment
      if (cntrlToClckArrlength != 0 && win.controlToClick[cntrlToClckArrlength] == null)
         return;
      if ((!isAstra() || cntrlToClckArrlength < maxNumofstoredClicks) && (cntrlToClckArrlength == 0 || (win.controlToClick[cntrlToClckArrlength -1].name != name || win.controlToClick[cntrlToClckArrlength -1].num != num || win.controlToClick[cntrlToClckArrlength -1].tsk != tsk)))
     {
         win.eval(self.controlToClick[cntrlToClckArrlength] = new controlDetails(name, num, tsk));
         win.controlToClickBegin = true;
         cntrlToClckArrlength ++;
       }
   }
}

/**
 * returns the isMagicEvent flag value
 */
function getMagicEvent()
{
   return isMagicEvent;
}

/**
 * Returns the Magic parent of a control
 * @param element the source control for which to find its Magic parent
 */
function getMagicParent(element)
{
   if (objExists(element) && objExists(element.parentElement))
   {
      var parent = element.parentElement;
      var parentName = parent.tagName;

      if (typeof parentName != JS_TYPE_STRING || parentName == CTRL_HTMLTYPE_BODY || parentName == CTRL_HTMLTYPE_HTML)
         return null;
      if (!isUnKnown(typeof parent.number))
         return parent;
      return getMagicParent(parent);
   }
}

/************************************************************************/
/* TABLES                                                               */
/************************************************************************/

/**
 * return the elements ancestor element which has the given tag name
 * @param element to check
 * @param name the requested ancestor tag name of element to check: 'TR', 'TABLE' (must be UPPERCASE)
 */
function getParentElm(element, name)
{
   var result = null;
   var child;
   var parent;

   if (objExists(element))
   {
      if (!objExists(element.parentElement))
      {
         // the element may be a Radio button so it has no parentElement
         if (typeof element.length == JS_TYPE_NUMBER && element.length > 0)
         {
            if ((typeof element[0].type != JS_TYPE_UNDEF) ||
                (typeof element[0].tagName != JS_TYPE_UNDEF))
               element = element[0];
            else
               element = null;
         }
         else
            element = null;
      }

      while (element != null && result == null)
      {
         child = element.tagName;
         parent = element.parentElement.tagName;

         if (parent == name)
            result = element.parentElement;
         else if (child == name)
            result = element;
         else if (parent == CTRL_HTMLTYPE_BODY || parent == CTRL_HTMLTYPE_HTML)
            element = null;
         else
            element = element.parentElement;
      }
   }
   return result;
}

/**
 * returns the table parent element for a given element
 * @param element the control for which to find the table parent element
 * @return reference to table, or null if element not contained in table
 */
function getTable(element)
{
   return getParentElm(element, CTRL_HTMLTYPE_TABLE);
}

/**
 * return the table row which contains a given element.
 * NOTE: The table must be a Magic table!
 * @param element the element which is in a row of a table
 */
function getTR(element)
{
   var tr = getParentElm(element, CTRL_HTMLTYPE_TR);
   var parentTbl;

   while (tr != null)
   {
      parentTbl = getParentElm(tr, CTRL_HTMLTYPE_TABLE);
      if (parentTbl != null)
         if (typeof parentTbl.tsk == JS_TYPE_UNDEF)
            tr = getParentElm(parentTbl, CTRL_HTMLTYPE_TR);
         else
            break;
      else
         tr = null;
   }

   return tr;
}

/*
 * this function updates the visibility of the table's borders.
 * @winNum - window number
 * @tableName - table control's name
 * @winPrefix - window's prefix
 * @visibleVal - new value of visibility property: visible|hidden
 */
function updateBordersVisibility(winNum, tableName, winPrefix, visibleVal)
{
   var win = getWin(winNum);
   var table = checkControlName(tableName, EMPTY_STR+winPrefix);
   var fTop;
   var fBottom;
   var fLeft;
   var fRight;
   var borderDivPrefix = EMPTY_STR;

   if (!objExists(table))
      return;

   if (table == null)
      return;

   borderDivPrefix = "mg_" + table.id;

   fTop = win.document.all[borderDivPrefix+"_top"];
   fBottom = win.document.all[borderDivPrefix+"_bottom"];
   fLeft = win.document.all[borderDivPrefix+"_left"];
   fRight = win.document.all[borderDivPrefix+"_right"];

   fTop.style.visibility=visibleVal;
   fBottom.style.visibility=visibleVal;
   fLeft.style.visibility=visibleVal;
   fRight.style.visibility=visibleVal;
}

/**
 * Draw borders on the current tables ROW
 * @param winNume number of the window
 * @param ctrlName the control name
 * @param winPrefix path to the window
 * @param forceChangeNumberOfLine (boolean) if the selected line has to be changed to another one
 *  (which containes control with ctrlName) if right now another line is selected
 */
function selectRow(winNum, ctrlName, winPrefix, forceChangeNumberOfLine)
{
   var win              = getWin(winNum);
   var ctrl             = checkControlName(ctrlName, EMPTY_STR+winPrefix);
   var tr;
   var fTop;
   var fBottom;
   var fLeft;
   var fRight;
   var direction        = EMPTY_STR;
   var left             = 0;
   var table            = null;
   var borderDivPrefix  = EMPTY_STR;

   if (!objExists(ctrl))
      return;

   tr = getTR(ctrl);       // reference to found <tr> tag (or null)

   if (tr != null)
      table=getTable(tr);  // get reference to the current table

   if (table == null || (!forceChangeNumberOfLine && table.prevTableTR != tr))
      return;              // the tabl doesn't exists or try to change number of line (tr) than it's impossible (from forceChangeNumberOfLine flag)

   // QCR 291902 we must try and take the simple border too
   // in any case the style border is always stronger
   if (table.border != null && table.border !="")
   {
      var temp = parseInt(table.border)
      left = (isNaN(temp) ? left : temp);
   }

   //755318 current style must be concidered too   
   if ( table.currentStyle != null && table.currentStyle.borderLeftStyle != "none"
        && table.currentStyle.borderLeftWidth != "")
   {
        var temp = parseInt(table.currentStyle.borderLeftWidth);
        left = (isNaN(temp) ? left : temp) ;
   }

   if ( table.style != null && table.style.borderLeftStyle != "none")
   {
      // QCR 276184 we must take the border from the style of the table
      if (table.style != null && table.style.borderLeftWidth != "")
      {
         var temp = parseInt(table.style.borderLeftWidth);
         left = (isNaN(temp) ? left : temp) ;
      }
   }

   // check the direction
   direction = getDirection (ctrl);
   if (direction == RTL_STR)
      left = left - table.offsetWidth;

   borderDivPrefix = "mg_" + table.id;

   fTop = win.document.all[borderDivPrefix+"_top"];
   fBottom = win.document.all[borderDivPrefix+"_bottom"];
   fLeft = win.document.all[borderDivPrefix+"_left"];
   fRight = win.document.all[borderDivPrefix+"_right"];

   // QCR 742361 if the div does not exist do not draw
   // (for example when the porperty of row highlighting is set to no)
   if (fTop == null || fBottom == null || fLeft == null || fRight == null)
        return;

   fTop.style.top = tr.offsetTop;
   fTop.style.left = left;
   fTop.style.width = tr.offsetWidth;

   fBottom.style.top = tr.offsetTop + tr.offsetHeight - 3;
   fBottom.style.left = left;
   fBottom.style.width = tr.offsetWidth;

   fLeft.style.left = left;
   fLeft.style.top = tr.offsetTop;
   fLeft.style.height = tr.offsetHeight;

   fRight.style.left = EMPTY_STR + (left + tr.offsetWidth - 2);
   fRight.style.top = tr.offsetTop;
   fRight.style.height = tr.offsetHeight;
}

/**
 * Returns the direction of the first parent that has the "dir" attribute defined.
 * @param ctrl the ctrl to be checked
 * @param checkCurrent check the direction of the given ctrl or start from its parent
 */
function getDirection (ctrl, checkCurrent)
{
   var parent;
   var direction = "";
   var lastTableDir = "";
   var hasInnerTables = false;

   if (typeof checkCurrent == JS_TYPE_BOOLEAN && checkCurrent)
      parent = ctrl;
   else
      parent = ctrl.parentElement;

   while (direction == "" && parent != null)
   {
      if (parent.tagName != CTRL_HTMLTYPE_TABLE)
      {
         if (parent.style.direction != "")
            direction = parent.style.direction;
         else
            direction = parent.dir;
      }
      else
      {
         if (hasInnerTables)
         {
            if (parent.dir != "" && lastTableDir == "")
            {
               lastTableDir = parent.dir;
            }
         }
         else
         {
            hasInnerTables = true;
         }
      }
      if (direction == "")
         parent = parent.parentElement;
   }
   if (direction == "")
      direction = lastTableDir;

   if (direction == "")
      direction = LTR_STR;

   return direction;
}

/**
 * Sets the direction of a control if it's different from the current
 * @param ctrlName the name of the control
 * @param dir the new direction
 */
function setSelectDirection(ctrlName, dir)
{
   var currDir;
   var ctrl;

   if (typeof ctrlName == JS_TYPE_STRING)
      ctrl = eval("document.all['"+ctrlName+"']");
   else
      ctrl = ctrlName;
   if (dir == "")
      dir = LTR_STR;
   currDir = getDirection(ctrl, true);
   if (currDir != dir)
      ctrl.style.direction = dir;
}


/**
 * Displays or hides a row of a table
 * @param ctrlName of the control
 * @param display true to display, false to hide
 */
function displayRow(ctrlName, display)
{
   var ctrl = checkControlName(ctrlName);
   var tr;
   var oldOffsetHeight;

   if (objExists(ctrl))
   {
      tr = getTR(ctrl); // get a reference to the row element
      if (tr != null)
      {
         oldOffsetHeight = tr.offsetHeight;  // save the old offset height
         changeSubtreeVisibility(tr, display);
         if (oldOffsetHeight > 0)
            tr.height = oldOffsetHeight;        // restore the height using the old offset height
      }
   }
}


/**
 * display or hide all the contents of a sub tree of a DOM object
 * called by displayRow()
 * @param obj reference to row or a descendent object of it
 * @param boolean if the row need be dysplayed
 */
function changeSubtreeVisibility(obj, display)
{
   var visibility = display ? EMPTY_STR : HIDDEN_CSS;
   var childNum;

   obj.style.visibility = visibility;
   // scan the child objects
   if (objExists(obj.children) && obj.children.length > 0)
   {
      for (childNum = 0; childNum < obj.children.length; childNum++)
          changeSubtreeVisibility(obj.children[childNum], display);
   }
}

function setControlStyle(ctrl, is2D)
{
   is2D = var2bool(is2D);
   if (is2D)
   {
      ctrl.style.borderWidth = "0px";
      ctrl.style.margin = "2px";
   }
   else
   {
      ctrl.style.borderWidth = "2px";
      ctrl.style.margin = "0px";
   }
}

/**
 * changes the border style of a control group
 * @param numberWnd window reference
 * @param ctrlName name of control to change (append '_' for repeatable controls)
 * @param count the number of rows in the table (for repeatable controls)
 * @param is2DStr true for 2D border, false for 3D border
 */
function setControlsStyle(numberWnd, ctrlName, count, is2DStr)
{
   var number     = 0;
   var suffix;
   var wnd2check  = getWin(numberWnd);
   var cmd = EMPTY_STR;
   var ctrlFullName;

   is2D = var2bool(is2DStr);

   do
   {
      if (count > 0)
         suffix = number;
      else
         suffix = EMPTY_STR;

      ctrlFullName = getFullName(ctrlName + suffix);
      if (is2D)
      {
         cmd = cmd + ctrlFullName + '.style.borderWidth = \"0px\"; ';
         cmd = cmd + ctrlFullName + '.style.margin = \"2px\"; ';
      }
      else
      {
         cmd = cmd + ctrlFullName + '.style.borderWidth = \"2px\"; ';
         cmd = cmd + ctrlFullName + '.style.margin = \"0px\"; ';
      }

      number++;

   } while (number < count)

   wnd2check.eval(cmd);
}

/**
 * returns the ID of the magic table that contains the control
 * @param ctrlNameList a string containing one or more control names separated by NAMES_SEPARATOR
 * @param magicTableNameList a string containing one or more names of magic table controls separated by NAMES_SEPARATOR
 * @returns a list of table IDs separated by NAMES_SEPARATOR. In case the control does not belong to a Magic table the
 *          retured ID would be "undefined" (e.g. NAMES_SEPARATOR + undefined + NAMES_SEPARATOR)
 */
function getMagicTableIDs(ctrlNameList, magicTableNameList)
{
   var table;
   var ctrlRef;
   var ctrlNameArray = ctrlNameList.split(NAMES_SEPARATOR);
   var i;
   var returnNameList = EMPTY_STR;

   for (i = 1; i < ctrlNameArray.length - 1; i++)
   {
      ctrlRef = eval (ctrlNameArray[i]);
      if (!objExists(ctrlRef))
      {
         returnNameList += NAMES_SEPARATOR + "undefined" + NAMES_SEPARATOR + "0";
         continue;
      }

      while ((table=getTable(ctrlRef)) != null)
      {
         if (table.id != null && table.id != "" && magicTableNameList.indexOf(NAMES_SEPARATOR + table.id + NAMES_SEPARATOR) >= 0)
         {
            returnNameList += NAMES_SEPARATOR + table.id;
            break;
         }
         ctrlRef = table.parentElement;
      }

      if (table == null)
         returnNameList += NAMES_SEPARATOR + "undefined";

      if (typeof ctrlRef.tagName != JS_TYPE_UNDEF && ctrlRef.tagName.toUpperCase() == CTRL_HTMLTYPE_TEXTAREA)
         returnNameList += NAMES_SEPARATOR + "1";
      else
         returnNameList += NAMES_SEPARATOR + "0";
   }

   if (returnNameList == EMPTY_STR)
      returnNameList = NAMES_SEPARATOR + NAMES_SEPARATOR;
   else
      returnNameList += NAMES_SEPARATOR;

   return returnNameList;
}

/************************************************************************/
/*RADIO                                                                 */
/************************************************************************/

/**
 * set the checked radio button
 * @param groupName the name of the radio group
 * @return reference to found radio button with 'value', owervise first radio in the group
 */
function setRadioChecked(groupName, value)
{
   var radioGrp = getRadioGroup(EMPTY_STR, groupName);
   if (typeof radioGrp == JS_TYPE_OBJ)
      return writeToRadio (radioGrp, value);
   return null;
}

/**
 * Set focus to the specified option of a radio button control
 */
function setRadioFocus(ctrlName, value)
{
   var radio = setRadioChecked(ctrlName, value);

   if (radio!=null)
      radio.focus();
}

/**
 * returns the index of the choosen option of a radio button
 */
function getRadioFocused(groupName, numWindow)
{
   var radioGrp = getRadioGroup(numWindow, groupName);

   for (var i=0; i< radioGrp.length; i++)
      if (radioGrp[i].checked)
         return i;
   return null;
}

/**Set CSS Class for all radio buttons from the group
 * @param radioGrp full reference to the radio group
 * @param new css class name
 */
function setRadioClass(radioGrp, cssName)
{
   for (var i=0; i< radioGrp.length; i++)
      radioGrp[i].className = cssName;
}

/**Set CSS Style for all radio buttons from the group
 * @param radioGrp - path/string to the group
 * @param value - new value of the propery
 */
function setRadioStyle(radioGrp, value)
{
   var grp = eval(radioGrp);

   for (var i=0; i< grp.length; i++)
      grp[i].style.cssText = value;
}

/**Set tooltip to every button of Rudio Buttons group
 * @param radio button group name, string
 * @param tooltip
 */
 function setRadioTooltip(groupName, tooltip)
 {
   var radioGrp= getRadioGroup(EMPTY_STR, groupName);

   for (var i=0; i< radioGrp.length; i++)
      radioGrp[i].title = tooltip;
 }

 /**Set color on Radio group members
  * @param radio button group name, string
  * @param background color
  * @param foreground color
  */
function setRadioColor(groupName, bgColor, fgColor)
{
   var radioGrp = getRadioGroup(EMPTY_STR, groupName);

   for (var i=0; i< radioGrp.length; i++)
   {
      radioGrp[i].style.backgroundColor = bgColor;
      radioGrp[i].style.color           = fgColor;
   }
}

 /**Check if any button from radio button group checked
  */
 function isRadioGroupChecked(groupName, numWindow)
 {
  var radioGrp = getRadioGroup(numWindow, groupName);
  for (var i=0; i< radioGrp.length; i++)
   if (radioGrp[i].checked)
      return true;
  return false;
 }

 /**is radio group or any of it's elements disabled
  */
 function isRadioGroupDisabled(groupName, numWindow)
 {
  var radioGrp = getRadioGroup(numWindow, groupName);
  if (typeof radioGrp.disabled == JS_TYPE_BOOLEAN)
   return radioGrp.disabled;
  for (var i=0; i< radioGrp.length; i++)
   if (radioGrp[i].disabled)
      return true;
  return false;
 }

 /**Set visibility of Radio Button Group
  *@param path to the group
  *@param visibility - boolean "hidden" or "visible"
  */
 function setRadioVisibility (groupName, visibility)
 {
   var radioGrp = eval (groupName);

   for (var i=0; i< radioGrp.length; i++)
   {
      if (!visibility)
         radioGrp[i].style.visibility = HIDDEN_CSS;
      else
         radioGrp[i].style.visibility = VISIBLE_CSS;
   }
 }

 /**
  * set the checked radio button
  * @param radioGrp a reference to the radio group
  * @return reference to found radio button with 'value', owervise first radio in the group
  */
function writeToRadio(radioGrp, newValue)
{
   var i;
   var isEmpty = (newValue.length == 0);

   for (i=0; i<radioGrp.length; i++)
   {
      if (radioGrp[i].value==newValue)
      {
         radioGrp[i].checked=true;
         return radioGrp[i];
      }
      radioGrp[i].checked=false;
   }
   // the value of radio difference from the value of control,
   // propably because the picture/musk invoked on the newValue, bug :6494
   var currIndx;
   var currVal;
   if (!isEmpty)
      for (i=0; i<radioGrp.length; i++)
      {
         currIndx= -1;              // init index
         currVal = radioGrp[i].value;
         if (currVal.length > newValue.length)
            currIndx = currVal.indexOf(newValue);
         if (currIndx == 0)       // found
         {
            radioGrp[i].checked=true;
            return radioGrp[i];
         }
      }
    else
      return null;

   return radioGrp[0];
}

/**
 * Get radio group reference
 * @param number of window
 * @param radio button group name, string
 * @return ref. to radio group
 */
function getRadioGroup(numWindow, groupName)
{
   return eval(numWindow + getFullName(groupName));
}

/** last stage of initing new windows/frams
* @parm isModal true if the new window should be modal
* @parm isFrame true if the new window goes into an existing frame --> OBSOLETE
* @parm newWndNum the new window's number (in the windowsArray structure)
* @parm openerWndNum the id of the window which opened this one.
*/
function initNewWindow(isModal, isFrame, newWndNum, openerWndNum)
{
   var mWnd = getMainWnd();
   var opener_ = self;
   var newWnd  = mWnd.windowsArray[newWndNum];

   isModal = var2bool(isModal);
   isFrame = var2bool(isFrame);

   // QCR #284805
   if (numberWnd != openerWndNum)
   {
      return mWnd.windowsArray[openerWndNum].eval("initNewWindow(" + isModal + ", " + isFrame + ", " + newWndNum + ", " + openerWndNum + ")")
   }

   var isInFrame = winIsFrame(newWnd);

   if (newWinInterval != null)
   {
      clearInterval(newWinInterval);
      newWinInterval = null;
      newWnd.setTimeout("runTimer(OPENWIN_TIMER, false)", 500); // one last time
   }

   if (isInFrame)
   {
      opener_ = self;
      isModal = false;
   }
   else
   {
      opener_ = mWnd.windowsArray[openerWndNum];
      isModal = (newWnd.MGWINDATA.innerHTML.indexOf("<modal>1</modal>") > -1) || isModal;
   }

   opener_.initNumbering (false, isModal, newWnd, newWndNum);

   if (isInFrame)
      mWnd.currWnd = newWndNum; // no need to focus here
   else
   {
      setCurrWnd(newWndNum);
      if (winIsMoveable(newWnd))
      {
         var winData = newWnd.MGWINDATA.innerHTML;

         // Parse the location data
         var locTagBegin = "<location>";
         var locTagEnd   = "</location>";
         var locBegin    = winData.indexOf(locTagBegin) + locTagBegin.length;
         var locEnd      = winData.indexOf("</location>")
         var loc = winData.substring(locBegin, locEnd);
         var commaPos = loc.indexOf(",");
         var top = new Number(loc.substring(0, commaPos));
         loc = loc.substring(commaPos + 1);
         commaPos = loc.indexOf(",");
         var left = new Number(loc.substring(0, commaPos));
         loc = loc.substring(commaPos + 1);
         commaPos = loc.indexOf(",");
         var width = new Number(loc.substring(0, commaPos));
         var height = new Number(loc.substring(commaPos + 1));
         if (height != -1 || width != -1)
         {
            if (height == -1)
               height = opener_.document.body.clientHeight;
            if (width == -1)
               width = opener_.document.body.clientWidth;

            newWnd.resizeTo(width, height);
         }
         if (top == -1)
            top = opener_.screenTop + 10;
         if (left == -1)
            left = opener_.screenLeft + 10;
         newWnd.moveTo(left, top);
      }
   }

   newWnd.isFrameSet = isInFrame;
   try
   {
      var xmlData = newWnd.MGDATA.innerHTML;
      // return xmlData.substring(0, xmlData.length - 3);
      return xmlData;
   }
   catch (e)
   {
      return null;
   }
}

/************************************************************************/
/*OPENING WINDOWS                                                       */
/************************************************************************/

/**make numeration and put all needed references to 1st page (applet inside)
 *this function must be used only 1st time .
 * @param isMainWnd - true only for first opened, main window, with applet
 * @param isModal - boolean, if the window is modal
 * @param reference to new opened window, need to be null to windows, poened from URL and real reference for window, opened from HTML
 */
function initNumbering(isMainWnd, isModal, newWnd, newWndNum)
{
   var aWindow = null;

   if (isMainWnd)
   {
      aWindow = self;

      // Add numberWnd to the Main window, and save its reference (to itself) in the first cell of windowsArray[]
      numberWnd                 = 0;                     // insert numberWnd attribute to every opened browser window, it's his number in 'browsersWnd' array
      number                    = 0;                     // meaningless variable
      tsk                       = MG_WINDOW_TASK;        // meaningless variable
      currWnd                   = 0;                     // number of current active browser window, saved ONLY in main window [0]
      isModal                   = false;                 // main window isn't modal
      appletRef                 = document.ClientManager;
      mainWnd                   = self;
      logicalOpener             = null;                  // there is no opener to main window
      windowsArray              = new Array(self);       // object which contain references to ALL opened windows
      IsMS_JVM                  = appletRef.get_isMS_JVM();

      if (objExists(window.parent) && objExists(window.parent.frames) && window.parent.frames.length > 1)
         isFrameSet = true;
   }
   else if (newWnd != null)                    // not main window opened from HTML/URL
   {
      if (newWnd.isNumberingDone)
         return;

      aWindow                 = newWnd;
      isNumberingDone         = true;
      newWnd.isNumberingDone  = true;
      newWnd.isLoaded         = false;
      newWnd.appletRef        = appletRef;
      newWnd.mainWnd          = getMainWnd();
      newWnd.logicalOpener    = self;
      newWnd.numberWnd        = newWndNum;                              // checked window MUST be added to the array before initNumbering (after window.open())
      newWnd.number           = newWnd.numberWnd;                          // meaningless variable
      newWnd.tsk              = MG_WINDOW_TASK;                               // meaningless variable
      newWnd.debugMode        = debugMode;
      newWnd.isModal          = (isModal == null ? false : isModal);
      if (!newWnd.isModal && !(getModalParent(newWndNum) === false))
         newWnd.isModal = true;

      newWnd.IsMS_JVM         = IsMS_JVM;
   }

   if (aWindow != null)
   {
      setMouseMove2VCR_EDIT(aWindow);

      try
      {
         if (typeof aWindow.top.ownerIsModal == JS_TYPE_UNDEF)
            aWindow.top.ownerIsModal = aWindow.isModal;

         if (typeof aWindow.top.ownerWinNum == JS_TYPE_UNDEF)
            aWindow.top.ownerWinNum = aWindow.numberWnd;
      } catch(e) {}

      // Put some debug information on Magic's errors window
      if (typeof aWindow.MG_ERRORS == JS_TYPE_OBJ)
         appendError (aWindow.MG_ERRORS.innerHTML);
   }
}

/**
 * returns the Magic XML data island planted on the page as a string
 */
function getXML()
{
   var wnd2check;

   if (!objExists(windowsArray))
      wnd2check = self;
   else
      wnd2check = getWin(getCurrWnd());
   if (typeof wnd2check.MGDATA == JS_TYPE_OBJ && wnd2check.MGDATA.readyState == "complete")
      return wnd2check.MGDATA.innerHTML;
                                             // must invoke free window after this function
   return "";                         // there is no XML, or XML not loaded, yet - it's problem of browser
}

/**
 * let the window process its events
 */
function freeWnd(winNum)
{
   var win = getWin(winNum);

   if (win != null)
      win.isLoaded = true;
}

/**Add mousemove handler to VCR and EDIT element in the window if the element exists
 * @param window to set handling to its elements
 */
function setMouseMove2VCR_EDIT(wnd)
{
   var ctrl;
   if (objExists(wnd.document.all.MG_VCR))
   {
      ctrl = wnd.document.all.MG_VCR;
      addHandlingToCtrl(ctrl, wnd);
   }
   if (objExists(wnd.document.all.MG_EDIT))
   {
      ctrl = wnd.document.all.MG_EDIT;
      addHandlingToCtrl(ctrl, wnd);
   }
   if (objExists(wnd.document.all.MG_CANCEL))
   {
      ctrl = wnd.document.all.MG_CANCEL;
      addHandlingToCtrl(ctrl, wnd);
   }
   if (objExists(wnd.document.all.MG_EXIT))
   {
      ctrl = wnd.document.all.MG_EXIT;
      addHandlingToCtrl(ctrl, wnd);
   }
   if (objExists(wnd.document.all.MG_QUIT))
   {
      ctrl = wnd.document.all.MG_QUIT;
      addHandlingToCtrl(ctrl, wnd);
   }
}

/**
 * Add MouseMove and MouseOver handling to control
 * @param ctrl to handle the events
 * @param wnd windows with reference to right function
 */
function addHandlingToCtrl(ctrl, wnd)
{
   if (ctrl != null)
   {
      ctrl.onmousemove = wnd.MGEventProcessingSpecial;
      ctrl.onmouseover = wnd.MGEventProcessingSpecial;
   }
}

/**set attribute number to all controls with name ctrlName_number
 * @param ctrlName the name of the control (including a '_' suffix).
 * @param number number of the control in its MGData ctrl table vector.
 * @param taskId of task, the control belongs to
 * @param repeatCntStr a string which holds the number of rows in the table that contains the control (e.g. "10").
 *        NOTE NOTE NOTE: if this parameter holds "0" then the control is not repeatable.
 * @param winNum number of the window to which the control belongs
 * @param ctrlType holds the control's type
 * @param addResizeHandler - boolean - true if resize handler has to be added to control (table), may be not used
 * @return "false" if not in Magic Controlled Table or control doesn't exist, overwise ID of the Table
 */
function setNumberToControl (ctrlName, number, tskNumber, taskId, repeatCntStr, winNum, ctrlType, addResizeHandler)
{
   var i  = 0;
   var cmd = EMPTY_STR;
   var wnd2check  = getWin(winNum);
   var repeatCnt  = parseInt(repeatCntStr);
   var isRadio    = (ctrlType == CTRL_TYPE_RADIO);
   var ctrl;
   var suffix;
   var ctrlFullName;
   var isSameType = null;

   // TODO : (ilan) if the debug flag is set for this window, also check the control exists and it's matching type
   do
   {
      // For non repeatable controls, we dont need to append any suffix to the name
      if (repeatCnt > 0)
         suffix = i;
      else
         suffix = EMPTY_STR;

      ctrlFullName = getFullName(ctrlName + suffix);

      if (debugMode > 0)
      {
         ctrl = wnd2check.eval(ctrlFullName);
         
         //QCR 304878 ( relevent only for opaque because for other controls it is checked
         // in the html_merge
         if ( typeof ctrl == JS_TYPE_UNDEF )
            abortOnError("the control "+ctrlName+" does not exist in HTML file");
		   
		   isSameType = isTheSameType (ctrl, ctrlType);
		   if (!isSameType)
		   {
		     var types = new Array(10);
		     var or = " or ";
		     types[CTRL_TYPE_BUTTON]     = CTRL_HTMLTYPE_BUTTON;
		     types[CTRL_TYPE_CHECKBOX]   = CTRL_HTMLTYPE_CHECKBOX;
		     types[CTRL_TYPE_RADIO]      = CTRL_HTMLTYPE_RADIO;
		     types[CTRL_TYPE_SELECT]     = CTRL_HTMLTYPE_SELECT+or+CTRL_HTMLTYPE_SELECT_MULT+or+CTRL_HTMLTYPE_SELECT_ONE;
		     types[CTRL_TYPE_TEXT]       = CTRL_HTMLTYPE_TEXT;
		     types[CTRL_TYPE_STATIC]     = CTRL_HTMLTYPE_TEXT;
		     types[CTRL_TYPE_TABLE]      = CTRL_HTMLTYPE_TABLE;
		     types[CTRL_TYPE_IMAGE]      = CTRL_HTMLTYPE_IMG;
		     types[CTRL_TYPE_HYPERTEXT]  = CTRL_HTMLTYPE_ANCHOR+or+CTRL_HTMLTYPE_DIV;
		     types[CTRL_TYPE_IFRAME]     = CTRL_HTMLTYPE_IFRAME;
		     abortOnError("The type of control "+ctrlName+" has to be of type "+types[ctrlType]);
		   }
		}
		
      if (isRadio)
      {
      }
      else
      {
         // if the control is opaque or IFRAME  then raise a flag that tells us not
         // to process the events on the control
         if (ctrlType == 'M' || ctrlType == 'O')
            cmd += ctrlFullName + ".cancelProcessing='true';";

         if (typeof addResizeHandler == JS_TYPE_BOOLEAN && addResizeHandler)
         {
            var table = eval(ctrlFullName);
            table.onresize = MGEventProcessing;
            table.onmove = MGEventProcessing;
         }
      }

      i++;

   } while (i < repeatCnt);

   // For performance reasons, we try (when possible) to execute all commands at "one shot"
   if (!isRadio)
      wnd2check.eval(cmd);
}

/**
 * add event processing to non Magic controls
 * @param window reference in form of string
 */
function addProcessingToNonMagicCtrls(winNum)
{
   var win = getWin(winNum)
   var elements = win.document.all;
   var elem;
   var i;
   var isTable;
   var realType;
   var mWnd = getMainWnd();
   
   mWnd.inOpenWin = false;

   for (i = 0; i < elements.length; i++)
   {
      elem = elements[i];
      realType = getCtrlType(elem);

      if (realType != null && !isMagicCtrl(elem))
      {
         isTable = (typeof elem.tagName != JS_TYPE_UNDEF && elem.tagName == CTRL_HTMLTYPE_TABLE);
         // add handling only if there is no user defined handler for the "focus" event
         if (!isTable && elem.onfocus == null)
            elem.onfocus = MGEventProcessing;
      }
   }
}

/**
 *Is the control was initialized at parsing time, like Magic control
 */
function isMagicCtrl(ctrl)
{
   if (typeof ctrl.number != JS_TYPE_UNDEF)
      return true;
   if (typeof ctrl.length == JS_TYPE_NUMBER && ctrl.length > 0)
      return isMagicCtrl(ctrl[0]);
   return false;
}

/**Get current value of control, if control is radio -> return number of checked radio
 * @param window
 * @param ctrlName name of control
 * @return string value of control
 */
function getControlValue(numWindow, ctrlName)
{
 var ctrl = eval (numWindow + getFullName(ctrlName));
 var realType;

 if (!objExists(ctrl))
   return EMPTY_STR;

 realType = getCtrlType(ctrl);

 if (realType == null)
   return EMPTY_STR;

 switch (realType)
   {
     case CTRL_TYPE_TEXT:
     case CTRL_TYPE_BUTTON:
     case CTRL_TYPE_STATIC:
        return ctrl.value;

     case CTRL_TYPE_SELECT:
     // IE automatically stuffs the value of selected OPTION
     // the control MUST have the value property in OPTION
         if (ctrl.type == CTRL_HTMLTYPE_SELECT_ONE)
            return ctrl.value;
         // CTRL_HTMLTYPE_SELECT_MULT
         return getMultipleSelectValue(ctrl);

     case CTRL_TYPE_CHECKBOX:
          if (ctrl.checked)
            return ONE_STR;
         return ZERO_STR;

     case CTRL_TYPE_IMAGE:
         return ctrl.src;

     case CTRL_TYPE_RADIO:
        var focused = getRadioFocused(ctrlName, numWindow);
        if (focused == null)
          return EMPTY_STR;
        return ctrl[ focused ].value;

     case CTRL_TYPE_HYPERTEXT:   // div & anchor
     case CTRL_TYPE_TABLE:
     default:
        return EMPTY_STR;
   }
}

/**If the control of the same type, as expected control type
 * @param reference to control
 * @param expected type of the control
 * @return true if the same type, false if not
 */
function isTheSameType(ctrl, expectedType)
{
   if (expectedType == 'O') 
      return true;
   var realType = null;
   if (!objExists(ctrl))
      return false;
   realType = getCtrlType(ctrl);
   if (realType == null)
      return false;
   // static is the same text in Magic, but without border
   if (expectedType == CTRL_TYPE_STATIC)
      expectedType = CTRL_TYPE_TEXT;
   if (realType != expectedType)
      return false;
   return true;
}

/**
 * @return type of control, or null if the control not identified
 */
function getCtrlType(ctrl)
{
   var realType = null;
   var type;

   if (!objExists(ctrl))
      return null;

   if (typeof ctrl.length == JS_TYPE_NUMBER)
   {
      if (objExists(ctrl[0])       &&
           typeof ctrl[0].type   != JS_TYPE_UNDEF &&
           typeof ctrl.tagName   == JS_TYPE_UNDEF &&
           ctrl[0].tagName       == CTRL_HTMLTYPE_INPUT)
         realType = CTRL_TYPE_RADIO;
      else if (typeof ctrl.tagName != JS_TYPE_UNDEF)
      {
       var name = ctrl.tagName;
       if (name == CTRL_HTMLTYPE_SELECT || name == CTRL_HTMLTYPE_SELECT_MULT ||
            name == CTRL_HTMLTYPE_SELECT_ONE)
         realType = CTRL_TYPE_SELECT
       }
   }
   else
   {
      if (typeof ctrl.type != JS_TYPE_UNDEF)
      {
         type = ctrl.type.toUpperCase();
         if (type == CTRL_HTMLTYPE_BUTTON)
           realType = CTRL_TYPE_BUTTON;
         else if (type == CTRL_HTMLTYPE_CHECKBOX)
            realType = CTRL_TYPE_CHECKBOX;
         else if (type == CTRL_HTMLTYPE_TEXT || type == CTRL_HTMLTYPE_TEXTAREA || type == CTRL_HTMLTYPE_PASSWORD ||
                   (ctrl.tagName == CTRL_HTMLTYPE_INPUT && type == EMPTY_STR))
             realType = CTRL_TYPE_TEXT;
         else if (type == CTRL_HTMLTYPE_IMG || type == CTRL_HTMLTYPE_IMAGE)
             realType = CTRL_TYPE_IMAGE;
         else if (typeof ctrl.tagName != JS_TYPE_UNDEF && ctrl.tagName == CTRL_HTMLTYPE_ANCHOR)
            realType = CTRL_TYPE_HYPERTEXT;
       }
       else if (typeof ctrl.tagName != JS_TYPE_UNDEF)
       {
          type = ctrl.tagName;
          if (type == CTRL_HTMLTYPE_TABLE)
            realType = CTRL_TYPE_TABLE;
          else if (type == CTRL_HTMLTYPE_IMG || type == CTRL_HTMLTYPE_IMAGE)
             realType = CTRL_TYPE_IMAGE;
          else if (type == CTRL_HTMLTYPE_ANCHOR || type == CTRL_HTMLTYPE_DIV)
             realType = CTRL_TYPE_HYPERTEXT;
          else if (type == CTRL_HTMLTYPE_IFRAME)
            realType = CTRL_TYPE_IFRAME;
       }
   }
 return realType;
}

/**
 *Is the control of select type
 */
function isSelectCtrl(ctrl)
{
   return (objExists(ctrl) && typeof ctrl.length == JS_TYPE_NUMBER && typeof ctrl.tagName != JS_TYPE_UNDEF);
}

/**
 *Is the control of Image type
 */
function isImg(ctrl)
{
   return (objExists(ctrl) && typeof ctrl.tagName == JS_TYPE_STRING && (ctrl.tagName == CTRL_HTMLTYPE_IMG || ctrl.tagName == CTRL_HTMLTYPE_IMAGE));
}

/**get value of multiple selected Select control
 * @param multiple-select control
 * @return comma delimeted value. If in source value of control were
 *  ", " or "-" it would changed to "\\, " and "\\-".
 */
function getMultipleSelectValue(ctrl)
{
   var currVal;
   var buffer=EMPTY_STR;
   var reMinus=/-/g;
   var reComma=/, /g;
   for (var i=0; i< ctrl.length; i++)
   {
      if (ctrl[i].selected)
      {
         currVal = ctrl[i].value;
         currVal =currVal.replace(reMinus, "\\-");
         currVal =currVal.replace(reComma, "\\, ");
         if (buffer == EMPTY_STR)
            buffer = currVal;
         else
            buffer += ", " + currVal;
      }
   }
   return buffer;
}

/**
 * returns true if running in an ASTRA checking environment
 */
function isAstra()
{
   var astra = getMainWnd().ASTRA;

   return (typeof astra == JS_TYPE_BOOLEAN && astra);
}

/**
 * returns true if a frame with the given name exists
 * @param frameName the name of the frame to find
 */
function frameExists(frameName)
{
   var result = true;

   if (getFrameWnd(frameName) == null)
      result = false;
   return result;
}

/**
 * returns a reference to the frame specified by frame name
 * @param nameOfFrame name of frame in frameset of parent, to open
 * @return reference to frame window
 */
function getFrameWnd(nameOfFrame)
{
   var result = null;

   if (nameOfFrame != null && nameOfFrame != "")
   {
      var winArray = getWindowsArray();
      var i;

      if (winArray != null && typeof winArray == JS_TYPE_OBJ)
      {
         for (i = 0; i < winArray.length && result == null; i++)
         {
            try 
            {
               if (objExists(winArray[i]) && 
                   objExists(winArray[i].top) && 
                   objExists(winArray[i].top.frames))
                  result = findFrameWnd(winArray[i].top, nameOfFrame, false);
            }
            catch (e)
            {
               result = null;
            }
         }
      }
   }
   return result;
}

/**
 * find frame by name in the frameset
 * @param frmSet parent frameset
 * @param nameOfFrame of the frameset to look for
 * @param returnPath true returns a path to the frame instead of a reference to it
 */
function findFrameWnd(win, nameOfFrame, returnPath)
{
   var i;
   var result = null;
   var prefix;
   var frmSet = win.frames;

   if (objExists(frmSet))
   {
      // look for the frame in the frameset
      try
      {
         result = frmSet[nameOfFrame];
      }
      catch(e){}
      
      if (typeof result == JS_TYPE_OBJ)
         if (returnPath)
            result = "$%$" + nameOfFrame;
         else;
      else
         result = null;
         
      // look into child framesets
      for (i = 0; i < frmSet.length && result == null; i++)
      {
         if (frmSet[i].frames.length > 0)
         {
            result = findFrameWnd(frmSet[i].frames, nameOfFrame, returnPath);
            if (result != null  && returnPath)
            {
               prefix = getSonFrameName (win, i);
               if (prefix != null && prefix != "")
                  result = "$%$" + prefix + result;
            }
         }
      }
   }
   return result;
}

/**
 * returns the path string to the frame in the following format:
 *    win_num$%$frame_name$%$frame_name$%$....
 * @param frameName the name of the frame to find
 */
function getPathToFrame(frameName)
{
   var result = null;

   if (frameName != null && frameName != "")
   {
      var winArray = getWindowsArray();
      var i;

      if (winArray != null && typeof winArray == JS_TYPE_OBJ)
      {
         for (i = 0; i < winArray.length && result == null; i++)
         {
            try
            {
               if (objExists(winArray[i]) && 
                   objExists(winArray[i].top) && 
                   objExists(winArray[i].top.frames))
                  result = findFrameWnd(winArray[i].top, frameName, true);
                  if (result != null)
                     result = "" + i + result;

            }
            catch (e)
            {
               result = null;
            }
         }
      }
   }
   return result;
}


/**open new window not connected to Magic program
 * @param html string contained new window
 * @param frame name of frame or empty string for opening a new window
 */
function openNewBrowserWindow(html, frame)
{
   var windowFeatures;
   var hasFrame = (frame != EMPTY_STR);
   var newWnd;

   if (hasFrame)
   {
      newWnd = getFrameWnd(frame);

      if (typeof newWnd == JS_TYPE_UNDEF || newWnd == null ||
          (typeof newWnd.document.ClientManager == JS_TYPE_OBJ &&
           (frame == "self" || frame == "top" || frame == "_self" || frame=="_top" ||
            frame == "parent" || frame == "_parent")))
         hasFrame = false;
   }

   if (isAstra() && !hasFrame)
      windowFeatures = WND_FEATURES_FULL;
   else
      windowFeatures = WND_FEATURES;

   if (!hasFrame)
      newWnd = window.open(EMPTY_STR, EMPTY_STR, windowFeatures);

   newWnd.document.open();
   newWnd.document.charset = document.charset;

   newWnd.document.write(html);
   newWnd.document.close();
}

/**Check if the URL is legal.
 * @param URL to check
 * @return legal URL for new opened page (string)
 */
function checkURL(url)
{
  if (url.indexOf("www.")==0)
   return "http:\\\\"+url;
  if (url.indexOf(":")==1)
   return "file:\\\\"+url;
  return url;
}

/************************************************************************/
/* CHECKING & CHANGING FOCUS / CURRENT WINDOW                           */
/************************************************************************/

/**
 * obtain the focus for this window according to the state and modality of
 * the current window
 */
function obtainFocus(newWinNum, preventFocus)
{
   preventFocus = var2bool(preventFocus);

   var currWnd = getCurrWnd();

   if (newWinNum == currWnd)
      return;

   var currWinRef = getWin(currWnd);
   preventFocusExec = preventFocus;
   if (!isWndClosed(currWnd))
   {
      if (typeof currWinRef.top.ownerIsModal != JS_TYPE_UNDEF && currWinRef.top.ownerIsModal && !(currWinRef.top == getWin(newWinNum).top))
      {
         // Modal window can set the focus ONLY to its descendant
         if (typeof currWinRef != JS_TYPE_UNDEF)
         {              // parent,  child
            if (!isChildOf(currWnd, newWinNum))
               setFocus(currWnd);               // set the focus back to current window
            else
               setCurrWndAndFocus(newWinNum);   // set the focus to the descendant
         }
         else
            checkFocusOfClosedWnd(currWnd);
      }
      else
         if (currWinRef.top.ownerIsModal != JS_TYPE_UNDEF && currWinRef.top.ownerIsModal && currWinRef.top == getWin(newWinNum).top)
            setCurrWndAndFocus(newWinNum);
         else
            checkModelessWndLostFocus(currWnd, newWinNum)
   }
   else
   {
      checkFocusOfClosedWnd(currWnd);
      // If focus remained on closed window - force to move it
      if (currWnd == getCurrWnd())
      {
         setFocus(newWinNum);
         setCurrWnd(newWinNum);
      }
   }
   preventFocusExec = false;
   return (getCurrWnd());
}

/**
 * set the current window and focus on it
 */
function setCurrWndAndFocus(wnd)
{
   var win;

   setCurrWnd(wnd);
   win = getWin(wnd);
   if (win.event == null || win.event.type != MOUSEDOWN)
      setFocus(wnd);
}

/**
 * Check lost focus event for modeless window
 * @param currWind current window, going to lost focus
 * @param numberWind number of window, which trying to get focus
 */
function checkModelessWndLostFocus(currWind, numberWind)
{
   var modalParent = getModalParent(currWind);

   if (modalParent === false)
   {
      // There is no modal parent to the current window -> bring focus to every one
      setCurrWndAndFocus (numberWind);
      return;
   }
   else
   {
      // not modal 'descendant' of modal window (modalParent) can bring focus only to
      // 'descendants' of the same modalParent (or parents 'predecessors')
      var modalParentChecked = getModalParent(numberWind);
      if (isWndModal(numberWind))
            modalParentChecked = numberWind;

      if (modalParentChecked===false)
         setFocus(currWind);
      else  // current window & new_checked window have modal parents
      {
         if (isChildOf(modalParent, modalParentChecked))
            setFocus(currWind);                   // bring focus back
         else
            setCurrWndAndFocus(numberWind);     // set focus to new window
      }
   } // end of else (have modal parent)
}

/**
 * Check and set focus to the opener window if current window is closed
 * @param currWnd number of current window
 */
function checkFocusOfClosedWnd(currWnd)
{
   var currWndOpener = getOpenerByNumber(currWnd); // find the logical opener of the window that was just closed

   if (currWndOpener == null)
      currWndOpener = getCurrWnd();

   if (currWnd != currWndOpener)
      setFocus(currWndOpener);
   setCurrWnd(currWndOpener);
}

/**Check if window with numberWnd=wnd have modal parent
 * @param wnd number of window to find his logical modal parents
 * @return number of logical Modal parent of wnd, or 'false' if there is no Modal parent
 */
function getModalParent(wnd)
{
   if (wnd==0)
      return false;

   var currWndOpener= getOpenerByNumber(wnd);

   if (typeof currWndOpener == JS_TYPE_UNDEF || currWndOpener == null || currWndOpener == ZERO_STR)
      return false;

   if (isWndModal(currWndOpener))
      return currWndOpener;    // the modal opener found
   return getModalParent(currWndOpener);
}

/**Check if window_child is one of 'descendants' of window_parent
 * @return true if child is logical 'descendant' of parent, overwise false
 */
function isChildOf(parent, child)
{
   if (child==0) // main window have no any parent
      return false;
   var childOpener= getOpenerByNumber(child);
   if (typeof childOpener == JS_TYPE_UNDEF || childOpener == ZERO_STR)
      return false;
   else if (childOpener == parent)
      return true;
   else
      return isChildOf(parent, childOpener);
}

/**
 * move the focus to the window with index numWnd
 */
function setFocus(numWnd)
{
   if (preventFocusExec)
      return;
   var win = getWin(numWnd);

   if (win == null || win.closed || typeof win.numberWnd == JS_TYPE_UNKNOWN || numWnd != getCurrWnd())
      return;

   try
   {
      if (typeof win.document.activeElement == JS_TYPE_OBJ)
         win.document.activeElement.focus();
      else
         win.focus();
   }
   catch (e) {}
}


/**
 * Check if window closed
 * @return true if closed, otherwise - false
 */
function isWndClosed(numWnd)
{
   var checkedWnd;

   checkedWnd = getWin(numWnd);
   if (checkedWnd == null)
      return true;
   return checkedWnd.closed;
}

/**
 * returns true if a window is modal
 * @param winNum the id of the window to check
 */
function isWndModal(winNum)
{
   var checkedWnd = getWin(winNum);

   if (checkedWnd == null || isUnKnown(checkedWnd.isModal))
      return false;
   return checkedWnd.isModal;
}

/**Find logical opener of not_closed/closed window
 * @param number of window to find it's logical opener
 * @return number of logical opener or null if the window is closed
 */
function getOpenerByNumber(childWnd)
{
   var wnd = getWin(childWnd);

   if (wnd == null || wnd.closed || !objExists(wnd.logicalOpener))
      return null;
   return wnd.logicalOpener.numberWnd;
}

/**
 * Set a new current window
 * @param newCurrWnd - index of the new current window in the windowsArray
 */
function setCurrWnd(newCurrWnd)
{
   var wnd = getMainWnd();

   if (wnd == null)
      return;

   wnd.currWnd = newCurrWnd;
   return;
}

/************************************************************************/
/* CLOSING WINDOW                                                       */
/************************************************************************/

/**
 * handle the unload event
 */
function checkUnLoad()
{
   var applet = getApplet();
   var winArray;
   var oldWinNum;
   var win;
   var i;

   if (isUnKnown(typeof numberWnd))
      numberWnd = 0;

   if (applet != null && (numberWnd == 0 || !isFrameSet || (frameIsInMainWin() == null)))
   {
      winArray = getWindowsArray();
      oldWinNum = numberWnd;
      if (typeof applet != JS_TYPE_UNDEF && winArray != null)
      {
         if (numberWnd == 0)
         {
            if (errorsWnd != null && typeof errorsWnd == JS_TYPE_OBJ && !errorsWnd.closed)
               errorsWnd.close();

            // close all the opened son windows
            for (i = 1; i < winArray.length; i++)
            {
               try
               {
                  win = winArray[i];
                  if (win != null && !win.closed)
                  {
                     win.isAborting = true;
                     closeDOMReferences(win);
                     if (!winIsFrame(win) && win.opener != null)
                        win.close();
                  }
               } catch (e) {}
            }
         }
         if (doNullify)
         {
            callProcessEvent(applet, UNLOAD, null, EMPTY_STR, null, null, numberWnd, null, null);
            if (oldWinNum > 0 && typeof winArray != JS_TYPE_UNDEF && winArray != null)
               winArray[oldWinNum] = null;
         }         
      }
   }
}

/**
 * returns true if there is a frame whose numberWnd == 0 within the same window
 */
function frameIsInMainWin()
{
	var topMostFrameSet;
	var result;
	
 	topMostFrameSet = top.frames;
	result = findInFrameSet(topMostFrameSet);
	return result;
}

/**
 * returns a reference to a frame if there is a frame whose (numberWnd == 0) under the given frameset
 * otherwise returns null
 * @param frmSet parent frameset
 */
function findInFrameSet(frmSet)
{
   var i;
   var result = null;

	for (i = 0; i < frmSet.length && !result; i++)
	{
		if (frmSet[i].frames.length > 0)
			result = findInFrameSet(frmSet[i].frames);
		else if (frmSet[i].numberWnd == 0)
			result = frmSet[i];
	}
	return result;
}

/**
 * opens standalone url in new window or in frame by control Name
 * @param ctrlName name of ctrl (hyperlink), href and target properties mus be already set.
 * @param wndNum   window number
 */
function openNewBrowserWindowURLctrl(ctrlName, wndNum)
{
   var wnd = getWin(wndNum);
   var ctrl = wnd.eval(getFullName(ctrlName));
   var url = checkURL(ctrl.href);
   openNewBrowserWindowURL(url, ctrl.target, wndNum);
}

/**
 * opens standalone url in new window or in frame by url and frame
 * @param url string (can include javascript commands)
 * @param frameName name of target frame
 */
function openNewBrowserWindowURL(url, frameName, winNum)
{
   var windowFeatures = WND_FEATURES;

   if (url.toLowerCase().indexOf("javascript:") == 0)
   {
      var wnd =  getWin(winNum);
      if (wnd == null || wnd.closed)
         return false;
   
      var start = url.indexOf(":");
      var end = url.length;
      if (end > start)
      {
         var command = url.substr(start + 1, end);
         try
         {
             wnd.eval(command);
         }
         catch (e) {}
      }
   }
   else if (frameName == null)
   {
      if (isAstra())
         windowFeatures = WND_FEATURES_FULL;

      win = window.open("", "", windowFeatures);
      win.blur();
      win.location.replace(url);
      win.focus();
   }
   else
        getWin(winNum).open(url, frameName);
}

/**
 * Close all opened windows,
 * navigate main window to url, or write html into the page.
 * @param url url of page
 * @param winNum number of the window
 * @param nonReversibleExit - is the exit command nonreversible
 * @param frameName name of the frame (in frameset) the new exit url need to be opened in
 * @param evtSrcHyperText true if the source of the event is a hypertest control
 */
function abortURL(url, winNum, nonReversibleExit, frameName, evtSrcHyperText)
{
   var win, mWnd;
   var left, top;
   var features;
   var destFrame = getFrameWnd(frameName); // destination Frame - exit url need to be opened in

   nonReversibleExit = var2bool(nonReversibleExit);

   url = checkURL(url);
   win = getWin(winNum);
   // the aborting window is the main window
   if (!nonReversibleExit)
   {
      if (destFrame == null)
      {
         win.isAborting = true;
         if (evtSrcHyperText)
            win.blur();
         win.location.replace(url);
         if (evtSrcHyperText)
            win.focus();
      }
      else
      {
         // If the url goes to a different frame - clear this one.
         if (typeof destFrame.numberWnd != JS_TYPE_NUMBER || destFrame.numberWnd != winNum)
			abortClose(winNum);
			
         destFrame.location.replace(url);
      }
   }
   else
   {
      mWnd = getMainWnd();
      features = WND_FEATURES_FULL;
      // when the window is closed by close button (X at the upper right side) there is bug of IE:
      // window.screenLeft/Top are changed to invalid values, out of the desktop/screen
      // so the window would be opened on default spot
      left = win.screenLeft;
      top  = win.screenTop;
      if (left < screen.availHeight && top < screen.availWidth)
      {
         features += ", height="+win.document.body.clientHeight+", ";
         features += "width="+win.document.body.clientWidth+", ";
         features += "left="+win.screenLeft+", ";
         features += "top=" +(win.screenTop-24);      // 24-pixel taskbar in 95-NT
      }
      abortClose(winNum);
      if (destFrame == null)
         mWnd.open (url, EMPTY_STR, features);
      else
         destFrame.location.replace(url);
   }
}

/** Close all opened windows,
 * change main window to new html page
 * @param string with html page inside
 * @param number of window to be closed
 * @param name of the frame the new exit html needs to be opened in
 */
function abortHTML(html, wndNmbr, frameName)
{
   var app;
   var mWnd;
   var destFrame = getFrameWnd(frameName);

   // if next page with another MagicApplet -> destroy current Applet
   app = getApplet();
   mWnd = getMainWnd();
   
   appletDestroyed = true;
   
   if (objExists(app) && wndNmbr == 0)
   {
      app.stop();
      app.destroy();
   }
   if ((objExists(mWnd) && objExists(mWnd.parent) && objExists(mWnd.parent.frames)) &&
         mWnd.parent.frames.length == 0)
   {
      closeDOMReferences(mWnd);
      mWnd.location.replace("about:" + html);
      
      // after changing inner HTML in body, the body's messages processing still alive
      mWnd.isAborting = true;

      // don't use close(), else open newWindow, write to newWindow and windowsArray[0].close();
   }
   else if (objExists(mWnd) && objExists(mWnd.parent)) // close all frames and catch all screen with html page
   {
      // destFrame not in use, yet
      setAbortFlag(true);
      closeDOMReferences(mWnd.parent);
      mWnd.parent.document.write(html);
      mWnd.parent.document.close();
   }
   else if (objExists(mWnd))
   {
      setAbortFlag(true);
      closeDOMReferences(mWnd);
      mWnd.document.write(html);
      mWnd.document.close();
   }
}

/**
 * Close the window and all it's sons,
 * returns true if it physically closes the window
 */
function  abortClose(winNum)
{
   var win = getWin(winNum);

   if (win == null || win.closed)
      return false;

   var cantClose = win.winAsFrame;

   win.isAborting = true;
   closeDOMReferences(win);
   
   if (winNum == 0 || winIsFrame(win) || cantClose || win.opener == null)
   {
      /* QCRs #296460 & 297700. Release the mouse and keyboard hooks 
       * before the "document" loses reference to the MGCOM
       */
      if (!IsMS_JVM && typeof document.all.MGcom == JS_TYPE_OBJ)
         document.all.MGcom.UnHookEvents(true);
      win.document.body.innerHTML = EMPTY_STR;
      return false;
   }
   else
   {
      var mWnd    = getMainWnd();
      var tm      = new Date();
      mWnd.afterCloseWin = tm.getTime();
      win.close();
      return true;
   }

}

/**
 * Clean references to main window and logical opener
 * @param win - the window is going to clean references
 */
function closeDOMReferences(win)
{
   if (win != null && (abortFlag == true || (typeof win.logicalOpener != JS_TYPE_UNDEF && typeof win.mainWnd != JS_TYPE_UNDEF)))
      deleteTimers(win);
}

/************************************************************************/
/* SERVICE FUNCTIONS                                                    */
/************************************************************************/

/**
 * set the tooltip of the VCR toolbar
 * @param source a reference to the VCR object
 * @param num the number of the toolbar icon
 */
function setVCRTooltip(source, num)
{
   switch(num)
   {
   case 1:
      // Begin Table
      source.title="\u30c6\u30fc\u30d6\u30eb\u5148\u982d";
      break;

   case 2:
      // Previous Screen
      source.title="\u524d\u753b\u9762";
      break;

   case 3:
      // Previous Row
      source.title="\u524d\u884c";
      break;

   case 4:
      // Next Row
      source.title="\u6b21\u884c";
      break;

   case 5:
      // Next Screen
      source.title="\u6b21\u753b\u9762";
      break;

   case 6:
      // End Table
      source.title="\u30c6\u30fc\u30d6\u30eb\u672b\u5c3e";
      break;
   }
}

/**
 * set the tooltip of the EDIT toolbar
 * @param source a reference to the EDIT object
 * @param num the number of the toolbar icon
 */
function setEDITTooltip(source, num)
{
   switch(num)
   {
   case 1:
      // Create Line
      source.title="\u884c\u4f5c\u6210";
      break;

   case 2:
      // Delete Line
      source.title="\u884c\u524a\u9664";
      break;

   case 3:
      // Cancel
      source.title="\u53d6\u6d88";
      break;
   }
}

/**
 * set the tooltip of the EDIT toolbar
 * @param source a reference to the EDIT object
 * @param num the number of the toolbar icon
 */
function setCANCEL_EXITTooltip(source)
{
   if (source.name == MG_CANCEL)
      source.title="Cancel";
   else if (source.name == MG_EXIT)
      source.title="Exit";
   else if (source.name == MG_QUIT)
      source.title="Quit";
}

/**
 * Write a message to the Status Bar
 * @param msg the message text
 * @param winNum the window number
 */
function writeStatus(msg, winNum)
{
   var win = getWin(winNum);

   if (win != null && !win.closed)
      win.status = msg;
}

/**Unselect control
 *@param name of the control to be unselected
 *@param numWindow reference to active window
 */
function unselect(ctrlName)
{
   var control   = eval(ctrlName);
   var oldValue  = control.value;
   control.value = EMPTY_STR;
   control.value = oldValue;
}

/**
 * display a message box
 * @param msg the message text
 * @param winNum the window number
 */
function writeToMessageBox(msg, winNum)
{
   var win = getWin(winNum);

   if (win != null && !win.closed)
      showAlert(win, msg);
}

/**
 * set the control value
 * @param numWindow reference to active window
 */
function writeToControl(ctrlName, newValue, numWindow)
{
   var ctrl = eval(numWindow + getFullName(ctrlName));
   var typeCtrl = getCtrlType(ctrl);

   if (typeCtrl == CTRL_TYPE_RADIO)
      writeToRadio(ctrl, newValue);
   else if (typeCtrl == CTRL_TYPE_CHECKBOX)
      ctrl.checked = (newValue == ONE_STR);
   else if (objExists(ctrl))
   {
      if (typeCtrl == CTRL_TYPE_SELECT)
         ctrl.oldValue = newValue;
      ctrl.value = newValue;
   }
}

/**Check validity of control name
 * @param ctrlName - string, name of control/object on the page
 * @param numWindow reference to active window
 *@return reference to control or null
 */
function checkControlName(ctrlName, numWindow)
{
  if (debugMode > 0 && (ctrlName == null || ctrlName == EMPTY_STR))
     return null;
  if (typeof numWindow == JS_TYPE_UNDEF)
     numWindow = EMPTY_STR;
  return eval(numWindow + getFullName(ctrlName));         // control: ctrl=...
}

/**@return number of current open/used window (int)
 */
function getCurrWnd()
{
   var main = getMainWnd();

   if (main != null && !main.closed)
      return main.currWnd;

   return -1;
}

/**
 * Execute a "timer" event
 * @param seconds the time interval in seconds
 * @param isIdleTimer true if this is the idle time "timer" event
 */
function runTimer(seconds, isIdleTimer)
{
   var currWin = getCurrWnd();
   var appl    = getApplet();
   var mWnd    = getMainWnd();

   if (seconds != OPENWIN_TIMER)
   {
      if (mWnd.inOpenWin)
         return;
         
      if (mWnd.afterCloseWin != 0)
      {
         var tm = new Date();
         if (tm.getTime() - mWnd.afterCloseWin < 1000)
            return;
         mWnd.afterCloseWin = 0;
      }    
   }
   else
   {
      if (inOpenWinTimer)
         return;
      inOpenWinTimer = true;
   }
   
      
   if (!isIdleTimer)
   {
      callProcessEvent(appl, TIMER, null, seconds, null, null, window.numberWnd, null, null);
      
      if (seconds == OPENWIN_TIMER)
         inOpenWinTimer = false;
   }
   else
   {
      try
      {
         var win = getWin(currWin);
         if (win == null || isUnKnown(typeof win.document) || isUnKnown(typeof win.document.scripts) || isUnKnown(typeof win.document.scripts["MGscript"]))
            return;
      }
      catch(e)
      {
         return;
      }

      callProcessEvent(appl, TIMER, "idle", seconds, null, null, currWin, null, null);
  }
}

/**
 * Start magic timer events
 * @param seconds the time interval in seconds
 * @param isIdleTimer true if this is the idle time "timer" event
 */
function runMagicTimer(seconds, isIdleTimer, winNum)
{
   var currWin;
   var cmd = "runTimer(" + seconds + ", " + isIdleTimer + ")";
   var length;

   if (isIdleTimer)
      currWin = getMainWnd();
   else
      currWin = getWin(winNum);

   // NOTE!!! a newly created JS object is PINNED to the window which created it, so make sure
   //         that object never outlives the creator (that's why we send the 'new Array()' to
   //         the right window.
   if (isUnKnown(typeof currWin.timers))
     currWin.eval ("self.timers = new Array()");

   length = currWin.timers.length;

   currWin.timers[length] = currWin.setInterval(cmd, seconds*1000);
}

/**
 * Clear all the "timer" events in the given window
 * @param wnd a reference to the window
 */
function deleteTimers(wnd)
{
   if (typeof wnd == JS_TYPE_OBJ && typeof wnd.timers == JS_TYPE_OBJ)
   {
      var length = wnd.timers.length;
      var idTimer;

      for (var i = 0; i < length; i++)
      {
         idTimer = wnd.timers[i];
         if (idTimer != null)
            clearInterval(idTimer);
      }
   }
}

/**
 * Bypass an IE feature that clears a form when Esc is pressed twice
 * @param evt current event
 */
function check4Esc(evt)
{
   if (evt.type==KEYDOWN)
   {
      var sourceType = evt.srcElement.type;

      if (typeof sourceType != JS_TYPE_STRING)
         sourceType = evt.srcElement.tagName;
      sourceType = sourceType.toUpperCase();

      // Change Esc keyCode to End keyCode
      if (evt.keyCode == KEY_ESC &&
         (sourceType == EMPTY_STR || sourceType == CTRL_HTMLTYPE_TEXT || sourceType == CTRL_HTMLTYPE_TEXTAREA ||
          sourceType == CTRL_HTMLTYPE_PASSWORD || sourceType == CTRL_HTMLTYPE_DIV || sourceType == CTRL_HTMLTYPE_ANCHOR))
         evt.keyCode = KEY_END;
   }
}

/**
 * returns a reference to the main window
 */
function getMainWnd()
{
   var mWin = mainWnd;

   if (isUnKnown(typeof mWin))
      mWin = null;

   if (mWin == null)
      abortOnError("Main window not found");
   return mWin;
}

/**
 * returns a reference to the global array of all windows
 */
function getWindowsArray()
{
   var mainW = getMainWnd();

   try
   {
      if (objExists(mainW) && !mainW.closed && objExists(mainW.windowsArray))
         return mainW.windowsArray;
   }
   catch (e) {}
   return null;
}

/**
 * returns a reference to the main Applet
 */
function getApplet()
{
   // try to found applets reference in itself
   if (typeof self.appletRef)
      return self.appletRef;
   // try to find applets reference in the main[0] window
   var mWnd = getMainWnd();

   if (mWnd != null)
      return mWnd.appletRef;
   status = "The Applet was not found !";
   return null;
}

/**
 * set the readonly attribute of a control
 * @param ctrlName name of control to set
 * @param value boolean value to use
 */
function setReadOnlyControl(ctrlName, value)
{
   var control = checkControlName(ctrlName);

   if (debugMode > 0 && !objExists(control))
      return;
   // the property influences only on next types of controls:
   // if (type==CTRL_HTMLTYPE_TEXT || type==CTRL_HTMLTYPE_ANCHOR || type==EMPTY_STR || type==CTRL_HTMLTYPE_TEXTAREA || type==CTRL_HTMLTYPE_PASSWORD)
   control.readOnly = value;
   return;
}

/**
 * Disable or enable controls
 * @param ctrlName the name of the control
 * @param value true / false
 */
function setDisableControl(ctrlName, value)
{
   var control = checkControlName(ctrlName);

   if (objExists(control))
   {
      if (typeof control.length != JS_TYPE_UNDEF && control.length > 0)
      {
         if (typeof control.tagName != JS_TYPE_UNDEF)
            control.disabled = value;
         for (var i = 0; i < control.length; i++)
            control[i].disabled = value;
      }
      else
      // button, checkbox, fileUpload, hidden, reset, submit, hypertext
         control.disabled = value;
   }
}

/**
 * get current CSS class of the control
 * @param ctrlName - the name of the control
 * @param numWindow - number of the controls window
 * @return name of the CSS class
 */
function getCtrlCssClass(ctrlName, numWindow)
{
   var control = eval(numWindow + getFullName(ctrlName));
   var css     = getCtrl(control).className;
   return css;
}

/**
 * get current CSS Stiles string of the control
 * @param ctrlName - the name of the control
 * @param numWindow - number of the controls window
 * @return inner string of the CSS style
 */
function getCtrlCssStyle(ctrlName, numWindow)
{
   var control = eval(numWindow + getFullName(ctrlName));
   var css     = "";

   try
   {
      css = getCtrl(control).style.cssText;
   }
   catch (e) {}
   return css;
}

/**
 * get control for getting inner information from it, like CSS
 * @param control reference to the control
 * @return ref. to control to get infrormation from it
 */
function getCtrl(control)
{
   var ctrl;

   // radio
   if (typeof control != JS_TYPE_UNDEF && typeof control.length != JS_TYPE_UNDEF && control.length > 0 && typeof control.tagName == JS_TYPE_UNDEF)
      ctrl = control[0];
   else
   // button, checkbox, fileUpload, hidden, reset, submit, hypertext
   // select :  typeof control.tagName != JS_TYPE_UNDEF
      ctrl = control;
   return ctrl;
}

/**
 * Process Magic External Event
 */
function MGExternalEvent()
{
   var args    = MGExternalEvent.arguments;
   var obj;
   var re      = /,/g;
   var length  = args.length;
   var value   = EMPTY_STR;
   var i       = 0;

   // build a value string from the arguments
   while (i < length)
   {
      obj  = EMPTY_STR + args[i];
      obj  = obj.replace(re, HTML_COMMA); // change inner commas to HTML_COMMA
      value += obj;
      if (++i < length) // don't add a comma after the last block
         value += COMMA_STR;
   }
   callProcessEvent(getApplet(), EXTERNAL, null, value, length, null, self.numberWnd, null, null);
}

/**
 * check if obj is undefined or unknown
 */
function isUnKnown(obj)
{
   return (obj == JS_TYPE_UNDEF || obj == JS_TYPE_UNKNOWN);
}

/**
 * returns true if the object exists
 */
function objExists(obj)
{
   return (obj != null && typeof obj == JS_TYPE_OBJ);
}


/************************************************************************/
/*MAGIC  FUNCTIONS                                                      */
/************************************************************************/

/**
 * Change the window dimensions
 * @param 1-SHOWNORMAL, 2-SHOWMAXIMIZED, 3-SHOWMINIMIZED
 */
function setMinMaxWin(size)
{
   moveTo(0, 0);
   if (size == ONE_STR)
      resizeTo(screen.availWidth*2/3, screen.availHeight*2/3);
   else if (size == "2")
      resizeTo(screen.availWidth, screen.availHeight);
   else if (size == "3")
      resizeTo(0, 0);
}

/**
 * Change the cursor shape for all the elements on the page
 * @param shape the new shape of the cursor
 */
function setCursor(shape)
{
   var obj;

   shape = "" + shape;

   for (var i = 0; i < document.all.length; i++)
   {
      if (typeof document.all.item(i).style != JS_TYPE_UNDEF)
          document.all.item(i).style.cursor = shape;
   }
   setCursorWithinBody(shape);
}

/**
 * Immediatelly changes the cursor shape for the body, by using the Magic/COM object
 * @param numWindow reference to the window
 * @param cursorForm the new shape

 */
function setCursorNow(numWindow, cursorForm)
{
   var wnd;
   var index = new Number(numWindow);

   wnd = getWin(index);

   try
   {
      if (wnd == null || typeof wnd.document != JS_TYPE_OBJ || typeof wnd.document.all.MGcom != JS_TYPE_OBJ)
         return;

      if (cursorForm == "wait")
         wnd.document.all.MGcom.ExecuteCmds("15;1;");
      else
         wnd.document.all.MGcom.ExecuteCmds("15;0;");
   }
   catch (e) {}
}

/**
 * Change the cursor shape for the body - helper function
 * @return form of old cursor
 */
function setCursorWithinBody(cursorForm)
{
   var oldCursor = document.body.style.cursor;

   document.body.style.cursor = cursorForm;
   return oldCursor;
}

/**
 * get properties of window
 * @param wndNum number of window in global array
 * @param propneeded size : "X", "Y", "H", "W"
 * @return needed size in pixels
 */
 function getWinProp(wndNum, prop)
 {
   var wnd;
   var index = new Number(wndNum);

   wnd = getWin(index);

   if (wnd == null)
      return 0;

   if (prop == "X")
      return wnd.screenLeft;
   else if (prop == "Y")
      return wnd.screenTop;
   else if (prop == "H")
      return wnd.document.body.clientHeight;
   else if (prop == "W")
      return wnd.document.body.clientWidth;
   else
      return 0;
 }

function setCOption(winNum, opt)
{
   var win = getWin(winNum);

   if (objExists(win) && typeof win.document.all.MGcom == JS_TYPE_OBJ)
      win.document.all.MGcom.ExecuteCmds(opt);
}

/**
 * returns a size property of a control
  * @param wndNum    window contain the control
  * @param ctrlName  name of control
  * @param prop      needed proprety name, string
  *@return              number, size
  */
 function getControlProp(wndNum, ctrlName, prop)
 {
   var wnd;
   var ctrl;

   wnd = getWin(wndNum);
   if (wnd == null)
      return 0;

   ctrl = wnd.eval(getFullName(ctrlName));
   if (!objExists(ctrl))
      return 0;
   if (prop == "clientWidth" || prop == "clientHeight")
      return getPadding(ctrl, prop) + ctrl.getAttribute(prop);
   return getClientLeftTop(ctrl, prop);
 }

 /**get padding width|height for control
  * @param control to get padding for.
  * @param param prop - 'clientWidth'/'clientHeight'
  * @return padding value for the control
  */
 function getPadding(ctrl, prop)
 {
   var padding    = 0;
   var style      = ctrl.style;
   var currStyle  = ctrl.currentStyle;

   // padding is not only added to the clientHeight|Width values, but the
   // padding size is doubled in the calculation
   if (prop == "clientWidth")
   {
      padding += getParam(style.paddingLeft, currStyle.paddingLeft)*2;
      padding += getParam(style.paddingRight, currStyle.paddingRight)*2;
   }
   else if (prop == "clientHeight")
   {
      padding += getParam(style.paddingTop, currStyle.paddingTop)*2;
      padding += getParam(style.paddingBottom, currStyle.paddingBottom)*2;
   }
   return padding;
 }

 /**get parameter from element1 or element2 (the element1 has tobe
  * prefered)
  * @return always numeric value or 0
  */
 function getParam(elm1, elm2)
 {
   var element;
   if (elm1 != EMPTY_STR)
      element = elm1;
   else if (elm2 != EMPTY_STR)
      element = elm2;
   else     // both are empty
      return 0;
   // string to numeric:
   if (typeof element != JS_TYPE_NUMBER)
   {
      if (typeof element == JS_TYPE_STRING)
         element = element.replace("px", EMPTY_STR);
      element = parseInt(element);
      if (!isNaN(element))
         return element;
   }
   return 0;
 }

 /**return real offset of element to BODY, and not to TR/TD/TABLE
  * @param ctrl inside/outside table
  * @param prop - 'clientLeft'/'clientTop'
  */
 function getClientLeftTop(ctrl, prop)
 {
   if (ctrl == null || ctrl == window)
      return 0;
   if (ctrl.style.position == "absolute")
      return ctrl.getAttribute(prop);
   return ctrl.getAttribute(prop)+getClientLeftTop(ctrl.offsetParent, prop);
 }

 /**check if function is defined on the HTML page
  * @param window the function need be in
  * @param name of needed function
  * @return '1' if the function found, '0' overwise
  */
 function isDefinedFunction(wndNum, funcName)
 {
   var wnd;

   wnd = getWin(wndNum);
   return (typeof wnd[funcName] == JS_TYPE_UNDEF) ? ZERO_STR : ONE_STR;
 }

 /**Execute function into specific window, the function involved from main window
  * @param wndNum window to execute function into it
  * @param cmnd sting contain comand to execute in specific window
  */
 function execInWnd(wndNum, cmnd)
 {
   var wnd = getWin(wndNum);

   if (wnd == null || wnd.closed || typeof wnd.isAborting != JS_TYPE_BOOLEAN || wnd.isAborting)
      return null;

   try
   {
      return wnd.eval(cmnd);
   }
   catch (e) {}
   return null;
 }

 /**translate an Object to boolean
  * @param val variable of Object
  * @return boolean type variable
  */
function var2bool(val)
{
   var bool = false;

   switch (typeof val)
   {
      case JS_TYPE_STRING:
         bool = (val == "true");
         break;
         
      case JS_TYPE_OBJ:
         bool = val.booleanValue();
         break;
         
      case JS_TYPE_BOOLEAN:
         bool = val;
         break;
         	
      default:
         bool = false;
         break;
   }
	
   return bool;
}

/************************************************************************/
/*MAGIC  EVENTS                                                         */
/************************************************************************/

/**
 * Set cursor to start or end of the field
 * @param ctrlName name of the control
 * @param direction to set cursor: Begin, End
 * @return FALSE if the control's window does not exist. Otherwise - TRUE.
 */
function setCursorInField(ctrlName, direction, winPrefix)
{
   var win = eval(winPrefix.substr(0, winPrefix.length - 1));

   if (win == null || typeof win != JS_TYPE_OBJ || win.closed)
      return false;

   var control = checkControlName(ctrlName, winPrefix);

   if (!objExists(control))
     return true;

   switch (direction)
   {
   case 'B':
      break;

   case 'E':
      // move the cursor to the end of the field
      if (!control.disabled && control.style.visibility != HIDDEN_CSS && control.style.display.toLowerCase().indexOf(DISPLAYNON_CSS) == -1)
      {
         try { control.focus(); } catch (e) {}
      }
      break;
   }

   return true;
}

/**Set focus to the radio button group
 * @param groupName name of radio buttons group
 * @param string "window.browserWndArray[number]." for exec function
 * @return FALSE if the control's window does not exist. Otherwise - TRUE.
 */
function setCursorInRadioField (groupName, winPrefix)
{
   var win = eval(winPrefix.substr(0, winPrefix.length - 1));

   if (win == null || typeof win != JS_TYPE_OBJ || win.closed)
      return false;

   var group = checkControlName(groupName, winPrefix);

   if (!objExists(group) || group.length <= 0)
      return true;
   // number of checked radio, or first [0] element in group
   var checked = getRadioFocused(groupName, winPrefix);
   checked = (checked==null) ? 0 : checked;
   group[checked].focus();
   return true;
}

/**
 * returns a reference to the window
 * @param winNum the number of the requested window
 */
function getWin(winNum)
{
   var winArray = getWindowsArray();
   var result;

   if (winArray != null && typeof winArray == JS_TYPE_OBJ && typeof winArray[winNum] == JS_TYPE_OBJ)
      result = winArray[winNum];
   else
   {
      var mainWnd = getMainWnd();
      // #994440 the main window is refreshing and not really closed :
      // if (!mainWnd.closed)
      // abortOnError("no window for winNum = " + winNum);
      result = null;
   }

   if (result != null && typeof result.MGDATA == JS_TYPE_UNDEF)
      result = null;
   return result;
}

/**
 * abort the operation of the client and print an appropriate message
 * @param eMsg the message to display
 */
function abortOnError(eMsg)
{
   var msg;

   msg = "Magic's Browser Client Internal Error:";
   msg += "\n" + eMsg;

   showAlert(null, msg);
}

/**
 * set the runtime debug level.
 * @param level the debug level (0 = none, 1 = yes or boolean value)
 */
function setDebugMode (level)
{
   debugMode = level;
}

/**
 * append an error message to the window which displays magic errors.
 * @param msg contains the message to be added. Note that the message is added to an ordered list
 *            (<OL></OL> tag, thus it should contain <LI> tag (e.g msg = "<LI>another error").
 */
function appendError (msg)
{
   var mainWin = getMainWnd();
   var wndExists = true;

   mainWin.errorsList = mainWin.errorsList + msg;
   if (mainWin.errorsWnd == null || typeof mainWin.errorsWnd != JS_TYPE_OBJ || mainWin.errorsWnd.closed)
      wndExists = false;

   if (!wndExists)
   {
      mainWin.errorsWnd = mainWin.open("", "__MG_Errors", WND_FEATURES + ", top=0, width=300");
      mainWin.errorsWnd.document.write("<HTML><HEAD><TITLE>Magic errors</TITLE></HEAD><BODY>" +
                                       "<OL ID=errors></OL></BODY></HTML>");
      mainWin.errorsWnd.document.all.errors.insertAdjacentHTML("AfterBegin", mainWin.errorsList);
   }
   else
      mainWin.errorsWnd.document.all.errors.insertAdjacentHTML("BeforeEnd", msg);

   mainWin.errorsWnd.focus();

}

/**
 * returns the full name of the control
 */
function getFullName (ctrlName)
{
   return 'document.all["' + ctrlName + '"]';
}

/**
 * Replaces the current set of options in a SELECT control with a new one
 * @param ctrlName the name of the control
 * @param value the new set of options
 */
function setOptionsToSelectCtrl(ctrlName, value)
{
   var select = eval(ctrlName);   // control is reference to needent control

   if (objExists(select))
   {
      select.options.length=0;
      var innerString = select.outerHTML;
      var index = innerString.indexOf('>');
      var left;
      index++;    // include '>'
      left = innerString.substring(0, index);
      innerString = left + value + innerString.substring(index);
      select.outerHTML = innerString;
   }
}

/**
 * checks if a specific xml data island has finished to be loaded and returns its data
 * @return "0" if the window/frame exists but the Magic script wasn't loaded yet
 *          "-1data" if the island was loaded
 *         "-2" problem 
 */
function isIslandLoadComplete(islandId,newWndNum, confirmWait, openerWndNum, confirmMsg)
{ 
   var mWnd    = getMainWnd();
   var newWnd  = mWnd.windowsArray[newWndNum];
   var xmlData;
   var confirmed;
      
   confirmWait = var2bool(confirmWait);

   if (newWnd == null || typeof newWnd == JS_TYPE_OBJ && newWnd.closed)
   {
      mWnd.inOpenWin = false;
      return "-2";
   }

   // QCR #284805
   if (numberWnd != openerWndNum)
      return mWnd.windowsArray[openerWndNum].eval( "isIslandLoadComplete(" + "'" + islandId + "', " + newWndNum + ", " + confirmWait + ", " + openerWndNum + ", '" + confirmMsg + "')" );
   
   // unhide slow loading windows (as long as they are not in a frame) and
   // get the user confirmation
   if (confirmWait)
   {
      if (!winIsFrame (newWnd))
         newWnd.moveTo(10, 10);
      confirmed = showConfirm(newWnd, confirmMsg);
      if (!confirmed)
         return "-2";
   }
     
  if (typeof newWnd.document.all[islandId] != JS_TYPE_OBJ  || newWnd.document.all[islandId].readyState != "complete" ||  newWnd.document.all[islandId].documentElement == null || newWnd.document.all[islandId].documentElement.xml == "")
     return "0";

  xmlData = newWnd.document.all[islandId].documentElement.xml;
   
  var refIds = newWnd.document.all[islandId].tagList;
      
   return ("-1," + refIds + "," + xmlData);

}

/**
 * checks for a Magic window/frame load status
 * @return "1" if the window/frame and its Magic scripts finished loading.
 *         "0" if the window/frame exists but the Magic script wasn't loaded yet
 *         "-1" if the window/frame does not exist.
 */
function isLoadComplete(newWndNum, confirmWait, openerWndNum, confirmMsg)
{
   var mWnd    = getMainWnd();
   var newWnd  = mWnd.windowsArray[newWndNum];
   var xmlData;
   var confirmed;
   var i;
   var href;

   confirmWait = var2bool(confirmWait);
   
   if (newWnd == null || typeof newWnd == JS_TYPE_OBJ && newWnd.closed)
   {
      mWnd.inOpenWin = false;
      return "-1";
   }

   // QCR #284805
   if (numberWnd != openerWndNum)
      return mWnd.windowsArray[openerWndNum].eval("isLoadComplete(" + newWndNum + ", " + confirmWait + ", " + openerWndNum + ", '" + confirmMsg + "')")

   if (newWnd.document.title == "Magic partitioning error")
   {
      if (!winIsFrame (newWnd))
         newWnd.moveTo(10, 10);
      mWnd.inOpenWin = false;
      return "-1";
   }

   if (newWnd.document.title == "Magic is going to close this window")
   {
      xmlData = newWnd.MGDATA.innerHTML;
      if (!winIsFrame (newWnd))
      {
         mWnd.windowsArray[newWndNum] = null;
         newWnd.close();
      }
      mWnd.inOpenWin = false;
      return "-1" + xmlData;
   }

   // unhide slow loading windows (as long as they are not in a frame) and
   // get the user confirmation
   if (confirmWait)
   {
      if (!winIsFrame (newWnd))
         newWnd.moveTo(10, 10);
      confirmed = showConfirm(newWnd, confirmMsg);
      if (!confirmed)
      {
         mWnd.inOpenWin = false;
         return "-2";
      }
   }
   
   if (isUnKnown(typeof newWnd) || isUnKnown(typeof newWnd.document.scripts) || isUnKnown(typeof newWnd.document.scripts["MGscript"]) || newWnd.document.scripts["MGscript"].readyState != "complete")
      return "0";

   if (typeof newWnd.MGDATA != JS_TYPE_OBJ || newWnd.MGDATA.innerHTML == "MGMG" || newWnd.MGDATA.innerHTML == "")
      return "0";

   xmlData = newWnd.MGDATA.innerHTML;
 
   return "1";
}

//goes over all xml data islands and checks if they are loaded
function allIslandsLoadComplete( newWndNum, confirmWait, openerWndNum, confirmMsg)
{
   var mWnd    = getMainWnd();
   var newWnd  = mWnd.windowsArray[newWndNum];
   var confirmed;
   var i;
   var href;
   
   confirmWait = var2bool(confirmWait);
   
   if (numberWnd != openerWndNum)
      return mWnd.windowsArray[openerWndNum].eval("allIslandsLoadComplete(" + newWndNum + ", " + confirmWait + ", " + openerWndNum + ", '" + confirmMsg + "')")



   // unhide slow loading windows (as long as they are not in a frame) and
   // get the user confirmation
   if (confirmWait)
   {
      if (!winIsFrame (newWnd))
         newWnd.moveTo(10, 10);
      confirmed = showConfirm(newWnd, confirmMsg);
      if (!confirmed)
      {
         mWnd.inOpenWin = false;
         return "-2";
      }
   }
   
   var xmls = newWnd.document.all.tags("XML");
   
   for( i = 0; i < xmls.length; i++)
   {
      if (typeof xmls[i] == JS_TYPE_OBJ)
      {
         if (xmls[i].src != null)
         {
              href = xmls[i].src;
               
              if (href.indexOf("/MG") == -1 || href.indexOf(".xml") == -1)
                  continue;
                  
              if (xmls[i].readyState != "complete")
                  return "0";
                  
              if (xmls[i].documentElement == null || xmls[i].documentElement.xml == "")
                  return "0";
          }
     }
   }
   return "1";   
}

// does a Magic window truelly exists?
function magicWindowExists (numWnd)
{
   var win = getWin(numWnd);

   if (typeof win == JS_TYPE_OBJ)
      return "1";
   else
      return "0";
}

/**
 * retuns true if the given control is parkable
 * @param ctrlName control name
 * @param winNum the index of the window
 */
function isParkable(ctrlName, winNum)
{
   var win = getWin(winNum);
   var ctrl;
   var i;

   if (win != null)
   {
      ctrl = win.eval (getFullName(ctrlName));

      if (ctrl != null)
      {
         // take care of radio buttons
         if (typeof ctrl.length == JS_TYPE_NUMBER && ctrl.length > 0)
         {
            for (i = 0; i < ctrl.length; i++)
               if (ctrl[i].checked)
                  break;
            if (i < ctrl.length)
               ctrl = ctrl[i];
            else
               ctrl = ctrl[0];
         }

         while (ctrl != null)
         {
            // In IE6 displays error, while trying to park on control with  style.cssText="DISPLAY :none"
            // In IE5 no control is in focus in this case. QCR #755136
            if (ctrl.disabled || ctrl.style.visibility == "hidden" || ctrl.style.display.toLowerCase().indexOf(DISPLAYNON_CSS) > -1)
               return false;
            ctrl = ctrl.parentElement;
         }
      }
   }
   return true;
}

function getCtrlIds(ctrlNames, wndNum)
{
   var ctrlids
   var wnd = getWin(wndNum);

   if (wnd == null || typeof wnd.isAborting != JS_TYPE_BOOLEAN || wnd.isAborting)
      return EMPTY_STR;

   ctrlids = wnd.document.all.MGcom.object.GetControlIds(ctrlNames);

   return ctrlids;
}

/**
 * returns the id of the owner window of the given window
 * @param winNum the id of the window for which to return the owner
 */
function getOwnerNum(winNum)
{
   var win     = getWin(winNum);
   var result  = winNum;

   if (objExists(win) && !win.closed && objExists(win.top) && !win.top.closed && typeof win.top.ownerWinNum != JS_TYPE_UNDEF)
      result = win.top.ownerWinNum;

   return result;
}

/** displays Url help for a window
 *   @param winNum the id of the window
 *   @param url Help url
 */
function displayUrlHelp(winNum, url)
{
   var win = getWin(winNum);
   win.showHelp(url);
}

/**
 * returns the name of the frame in which the window is hosted
 * @param winNum the id of the window for which to return the frame name
 */
/**
 * returns the WINDATA of the given window
 * @param winNum the id of the window for which to return the WINDATA
 */
function getWinDataXml(winNum)
{
   var win     = getWin(winNum);
   var result  = "";

   if (objExists(win))
      result = win.MGWINDATA.innerHTML;

   return result;
}

/**
 * replaces the location of a browser window by a url + data using POST method
 * @param aWinRef a reference to the target window object
 * @param aURL the destination URL
 * @param
 */
function postURL(aWinRef, aURL, aApp, aCTX, aSession, additionalArgs, additionalVars, XMLData)
{
   // prepare the HTML to write into the page
   var strHTML;
   var method = "POST";
   var fname  = 'form' + aSession

   strHTML =
   "<FORM name='" + fname + "' method='" + method + "' action='" + aURL + "' + ENCTYPE='application/x-www-form-urlencoded'>"
   + "\n<input type=hidden name='CTX'     value='"  + aCTX     + "'>"
   + "\n<input type=hidden name='SESSION' value='"  + aSession + "'>"
   + "\n<input type=hidden name='APPNAME' value='"  + aApp     + "'>";
   
   if (additionalArgs != null)
      strHTML += "\n<input type=hidden name='ARGUMENTS' value='"  + additionalArgs + "'>";
   if (additionalVars != null)
      strHTML += "\n<input type=hidden name='VARIABLES' value='"  + additionalVars + "'>";
   
   strHTML += "\n<input type=hidden name='DATA'    value='"  + XMLData  + "'></FORM>";

   try
   {
      if (typeof aWinRef.MGDATA == JS_TYPE_OBJ)
         aWinRef.MGDATA.innerHTML = "MGMG";

      aWinRef.document.body.innerHTML += strHTML;
   }
   catch (e)
   {
      strHTML = "<HTML><BODY>" + strHTML + "</BODY></HTML>";
      aWinRef.document.open();
      aWinRef.document.write(strHTML);
      aWinRef.document.close();
   }

   aWinRef.document.all[fname].submit();
}

/**
 * opens a new task tree in a new browser window or frame
 * @param openerNum id of the opener window
 * @param mgdNum id of MGData that will contain the new window
 * @param frame the name of the frame which will be the container of the new tasks tree
 * @param contextId the id of the context
 * @param sessionCount the serial id of the request
 * @param byBatch true if this winod is opened in response to a stand-alone batch program callin a BC task
 * @param XMLData the data to send to the server
 */
function openWin(openerNum, mgdNum, frame, winName, aURL, aApp, contextId, sessionCount, byBatch, XMLData)
{
   var mWnd = getMainWnd();
   var arrayWnd;
   var win;
   var logicalOpener;
   var windowFeatures ;
   var useSAwindow = var2bool(byBatch);
   var additionalArgs = null;
   var additionalVars = null;

   mWnd.inOpenWin = true;

   if (isAstra())
      windowFeatures = WND_FEATURES_FULL;
   else
      windowFeatures = WND_FEATURES;

   windowFeatures += "left=10000, top=10000, scrollbars=yes";

   // insert the new opening window to array
   arrayWnd = getWindowsArray();
   logicalOpener = arrayWnd[openerNum];
   
   if (useSAwindow && mWnd.standAloneWin != null)
   {
      win = mWnd.standAloneWin;
      mWnd.standAloneWin = null;
      additionalArgs = cutURLParm("ARGUMENTS", mWnd.standAloneUrl);
      if (additionalArgs == null)
         additionalArgs = cutURLParm("ARGS", mWnd.standAloneUrl);
      additionalVars = cutURLParm("VARIABLES", mWnd.standAloneUrl);
      if (additionalVars == null)
         additionalVars = cutURLParm("VARS", mWnd.standAloneUrl);
   }
   //QCR 997391  if a null string sent from the applet as the winName - it is recived as "undefined" in the javascript
   else if (typeof winName != JS_TYPE_UNDEF && winName != "" && typeof arrayWnd[mgdNum] != JS_TYPE_UNDEF && arrayWnd[mgdNum] != null)
   {
      win = arrayWnd[mgdNum];
      win.doNullify = false;
   }
   else if (frame == "")
      win = logicalOpener.open("", "", windowFeatures);
   else
   {
      win = getFrameWnd(frame);
      
      if (win == null)
         win = logicalOpener.open("", "", windowFeatures);
      else
         win.doNullify = false;
   }

   // add the new window to the windowsArray
   arrayWnd[mgdNum] = win;

   if (logicalOpener.newWinInterval == null)
      logicalOpener.newWinInterval = logicalOpener.setInterval("runTimer(OPENWIN_TIMER, false)", 100);
   logicalOpener.postURL(win, aURL, aApp, contextId, sessionCount, additionalArgs, additionalVars, XMLData);
}

/**
 * return true if win is a FRAME/IFRAME. We also check that the container is a window object
 */
function winIsFrame(win)
{
   var isFrame = false;

   try
   {
      if (win.top != win)
         isFrame = true;
   } catch (e) {}

   return isFrame;
}

/**
 * return true if win is in FRAME/IFRAME, therfore, not moveable
 */
function winIsMoveable(win)
{
   var isMoveable = false;

   try
   {
      if (win.top == win)
         isMoveable = true;
   } catch (e) {}

   return isMoveable;
}

/**
 * sets abortFlag
 * @param value of abortFlag
 */
function setAbortFlag(flag)
{
   abortFlag = flag;
}

/**
 * find the name of the frame which appears in cell 'win'.frames['idx'] 
 * @parm win - window which holds the frameset vector
 * @parm idx - index into the frames vector
*/
function getSonFrameName (win, idx)
{
   var fname = win.frames[idx].name;
   var names = false;
   
   if (fname != null && fname != "")
      return fname;
      
   for (f in win.frames)
   {
      if (f == null || f == "")
         continue;
         
      if (!names && f == "name")
         names = true;
      else if (names && win.frames[idx] == win.frames[f])
         return f;
   }
   
   return null;
}

function setWinAsFrame(winNum)
{
   var win     = getWin(winNum);

   //showAlert (null, " " + winNum);
   if (objExists(win))
      win.winAsFrame = true;
}

function getFrameName(winNum)
{
   var win     = getWin(winNum);
   var parentWin;
   var names = false;

   if (objExists(win) && winIsFrame(win))
   {
      parentWin = win.parent;
      for (f in parentWin.frames)
      {
         if (f == null || f == "")
            continue;
            
         if (!names && f == "name")
            names = true;
         else if (names && win == parentWin.frames[f])
            return f;
      }
   }

   return "";
}

/* Show the Message in the specified window
 * ensure that we release the mouse and keyboard hooks 
 * while the alert box is open
 */
function showAlert(win, msg)
{
   if (!IsMS_JVM)
      if (typeof document.all.MGcom == JS_TYPE_OBJ)
         document.all.MGcom.UnHookEvents(true);
   
   if(win != null)   
      win.alert(msg);
   else
      alert(msg);

   if (!IsMS_JVM)
      if (typeof document.all.MGcom == JS_TYPE_OBJ)
         document.all.MGcom.HookEvents(true);
}

/* Show the Message in the specified window
 * ensure that we release the mouse and keyboard hooks 
 * while the confirm box is open
 */
function showConfirm(win, msg)
{
   var ret;
   
   if (!IsMS_JVM)
      if (typeof document.all.MGcom == JS_TYPE_OBJ)
         document.all.MGcom.UnHookEvents(true);
   
   if(win != null)   
      ret = win.confirm(msg);
   else
      ret = confirm(msg);

   if (!IsMS_JVM)
      if (typeof document.all.MGcom == JS_TYPE_OBJ)
         document.all.MGcom.HookEvents(true);
         
   return ret;
}

// cuts a parameter value out of a URL string
function cutURLParm(parmName, url)
{
   if (parmName == null || url == null)
      return null;
      
   var parmEq = parmName + "=";
   var beginOff = url.indexOf(parmEq);
   var endOff;
   
   if (beginOff < 0)
      return null;
   
   beginOff += parmEq.length;
   
   endOff = url.indexOf("&", beginOff);
   if (endOff < 0)
      return url.substring(beginOff);
   else
      return url.substring(beginOff, endOff - 1);
}

/* Returns document body direction "rtl"/"ltr"
 */
 function getBodyDirection(wndNum)
 {
   var dir = "ltr";
   var wnd = getWin(wndNum);
   
   if ( wnd != null && wnd.document != null && wnd.document.body != null)
      dir = wnd.document.body.dir;
      
   return dir;
 }
 
 /**
  * this function is call by the batch redirect intermidate html
  * does the logic needed in order to call browser client window from batch
  * this function is called from the inner IFRAM on the main window (alway)
  * in order to allow c# Compatibility 
  */
  function callBatchOpenWin(t,u)
  {
      if(standAloneWin!=null)
         return;
              
      standAloneWin = t;
      standAloneUrl = u;
      var rc;
      var c = 0;
   
      rc = callProcessEvent(getApplet(),"standalone",null,u,0,null,0,null,null);
      while(rc == PROCESS_EVENT_BUSY_RETRY && c < 30)
      {
         document.all.MGcom.ExecuteCmds("25;1000;");
         rc = callProcessEvent(getApplet(),"standalone",null,u,0,null,0,null,null);
         c++;
      }
  }